/* Driver template for the LEMON parser generator.
** The author disclaims copyright to this source code.
*/
/* First off, code is include which follows the "include" declaration
** in the input file. */
#include <stdio.h>
#line 12 "mdcTclParse.y"


#define _POSIX_SOURCE 1

#include <stddef.h>							/* NULL, size_t, and so on */
#include <malloc.h>
#include <tcl.h>
#include "../general.h"
#include "TclListUtils.h"

extern int 
seshlex();

void 
yyerror(char *s);

#include <stdio.h>
#ifndef NULL
#define NULL 0
#endif

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif
 
 struct MdcParseContext {
	 Tcl_Interp *interp;
	 Tcl_Obj *result;
 };

#line 40 "mdcTclParse.c"
/* Next is all token values, in a form suitable for use by makeheaders.
** This section will be null unless lemon is run with the -m switch.
*/
/* 
** These constants (all generated automatically by the parser generator)
** specify the various kinds of tokens (terminals) that the parser
** understands. 
**
** Each symbol here is a terminal symbol in the grammar.
*/
/* Make sure the INTERFACE macro is defined.
*/
#ifndef INTERFACE
# define INTERFACE 1
#endif
/* The next thing included is series of defines which control
** various aspects of the generated parser.
**    YYCODETYPE         is the data type used for storing terminal
**                       and nonterminal numbers.  "unsigned char" is
**                       used if there are fewer than 250 terminals
**                       and nonterminals.  "int" is used otherwise.
**    YYNOCODE           is a number of type YYCODETYPE which corresponds
**                       to no legal terminal or nonterminal number.  This
**                       number is used to fill in empty slots of the hash 
**                       table.
**    YYACTIONTYPE       is the data type used for storing terminal
**                       and nonterminal numbers.  "unsigned char" is
**                       used if there are fewer than 250 rules and
**                       states combined.  "int" is used otherwise.
**    ParseTOKENTYPE     is the data type used for minor tokens given 
**                       directly to the parser from the tokenizer.
**    YYMINORTYPE        is the data type used for all minor tokens.
**                       This is typically a union of many types, one of
**                       which is ParseTOKENTYPE.  The entry in the union
**                       for base tokens is called "yy0".
**    YYSTACKDEPTH       is the maximum depth of the parser's stack.
**    ParseARGDECL       is a declaration of a 3rd argument to the
**                       parser, or null if there is no extra argument.
**    ParseKRARGDECL     A version of ParseARGDECL for K&R C.
**    ParseANSIARGDECL   A version of ParseARGDECL for ANSI C.
**    YYNSTATE           the combined number of states.
**    YYNRULE            the number of rules in the grammar
**    YYERRORSYMBOL      is the code number of the error symbol.  If not
**                       defined, then do no error processing.
*/
/*  */
#define YYCODETYPE unsigned char
#define YYNOCODE 51
#define YYACTIONTYPE unsigned char
#define ParseTOKENTYPE Tcl_Obj *
typedef union {
  ParseTOKENTYPE yy0;
  int yy92;
  int yy101;
} YYMINORTYPE;
#define YYSTACKDEPTH 100
#define ParseARGDECL ,context
#define ParseXARGDECL struct MdcParseContext *context;
#define ParseANSIARGDECL ,struct MdcParseContext *context
#define YYNSTATE 64
#define YYNRULE 52
#define YYERRORSYMBOL 29
#define YYERRSYMDT yy101
#define YY_NO_ACTION      (YYNSTATE+YYNRULE+2)
#define YY_ACCEPT_ACTION  (YYNSTATE+YYNRULE+1)
#define YY_ERROR_ACTION   (YYNSTATE+YYNRULE)
/* Next is the action table.  Each entry in this table contains
**
**  +  An integer which is the number representing the look-ahead
**     token
**
**  +  An integer indicating what action to take.  Number (N) between
**     0 and YYNSTATE-1 mean shift the look-ahead and go to state N.
**     Numbers between YYNSTATE and YYNSTATE+YYNRULE-1 mean reduce by
**     rule N-YYNSTATE.  Number YYNSTATE+YYNRULE means that a syntax
**     error has occurred.  Number YYNSTATE+YYNRULE+1 means the parser
**     accepts its input.
**
**  +  A pointer to the next entry with the same hash value.
**
** The action table is really a series of hash tables.  Each hash
** table contains a number of entries which is a power of two.  The
** "state" table (which follows) contains information about the starting
** point and size of each hash table.
*/
struct yyActionEntry {
  YYCODETYPE   lookahead;   /* The value of the look-ahead token */
  YYACTIONTYPE action;      /* Action to take for this look-ahead */
  struct yyActionEntry *next; /* Next look-ahead with the same hash, or NULL */
};
static struct yyActionEntry yyActionTable[] = {
/* State 0 */
  {  44,   1, 0                    }, /*        startingGarbage shift  1 */
  {  29,  62, 0                    }, /*                  error shift  62 */
  {  38, 117, 0                    }, /*                mdcfile accept */
  {  23,  63, 0                    }, /*                WORDEND shift  63 */
/* State 1 */
  {  48,   2, 0                    }, /*              textitems shift  2 */
/* State 2 */
  {  16,  51, &yyActionTable[   6] }, /*              SEPARATOR shift  51 */
  {   0,  64, 0                    }, /*                      $ reduce 0 */
  {   2,  92, 0                    }, /*         BEGINCARTOUCHE reduce 28 */
  {  19,  92, &yyActionTable[  12] }, /*                 SYMBOL reduce 28 */
  {  20,  92, &yyActionTable[  13] }, /*                   TEXT reduce 28 */
  {  21,  92, &yyActionTable[  18] }, /*              TEXTSUPER reduce 28 */
  {  22,  92, 0                    }, /*                 TOGGLE reduce 28 */
  {   3,  92, 0                    }, /*      BEGINOLDCARTOUCHE reduce 28 */
  {   4,  92, 0                    }, /*              BEGINPHIL reduce 28 */
  {  41,   3, 0                    }, /*           optSeparator shift  3 */
  {  10,  92, 0                    }, /*                GRAMMAR reduce 28 */
  {  11,  92, 0                    }, /*             HIEROGLYPH reduce 28 */
  {  12,  92, 0                    }, /*                LINEEND reduce 28 */
  {   5,  92, 0                    }, /*                   BPAR reduce 28 */
  {YYNOCODE,0,0}, /* Unused */
  {  15,  92, 0                    }, /*                PAGEEND reduce 28 */
/* State 3 */
  {  32,  35, 0                    }, /*    hieroglyphsOrSymbol shift  35 */
  {  33,  24, 0                    }, /*             inhierlist shift  24 */
  {  34,  18, &yyActionTable[  27] }, /*            inhierlists shift  18 */
  {  35,  49, &yyActionTable[  28] }, /*              ligatures shift  49 */
  {   4,  22, 0                    }, /*              BEGINPHIL shift  22 */
  {   5,  27, 0                    }, /*                   BPAR shift  27 */
  {   2,  53, 0                    }, /*         BEGINCARTOUCHE shift  53 */
  {   3,  59, 0                    }, /*      BEGINOLDCARTOUCHE shift  59 */
  {  40,  41, 0                    }, /*             optGrammar shift  41 */
  {  15,   8, 0                    }, /*                PAGEEND shift  8 */
  {  10,  47, 0                    }, /*                GRAMMAR shift  47 */
  {  11, 106, 0                    }, /*             HIEROGLYPH reduce 42 */
  {  12,   7, 0                    }, /*                LINEEND shift  7 */
  {  45,  23, 0                    }, /*              subcadrat shift  23 */
  {  46,  15, 0                    }, /*             subcadrats shift  15 */
  {  47,   4, &yyActionTable[  30] }, /*               textitem shift  4 */
  {YYNOCODE,0,0}, /* Unused */
  {  49,   5, 0                    }, /*              topcadrat shift  5 */
  {YYNOCODE,0,0}, /* Unused */
  {  19,  48, 0                    }, /*                 SYMBOL shift  48 */
  {  20,  11, 0                    }, /*                   TEXT shift  11 */
  {  21,   9, 0                    }, /*              TEXTSUPER shift  9 */
  {  22,  10, 0                    }, /*                 TOGGLE shift  10 */
  {YYNOCODE,0,0}, /* Unused */
  {  24,  12, 0                    }, /*                 cadrat shift  12 */
  {YYNOCODE,0,0}, /* Unused */
  {  26,   6, 0                    }, /*              cartouche shift  6 */
  {YYNOCODE,0,0}, /* Unused */
  {  28,  21, 0                    }, /*            complexsign shift  21 */
  {YYNOCODE,0,0}, /* Unused */
  {  30,  50, 0                    }, /*             hieroglyph shift  50 */
  {  31,  38, 0                    }, /*            hieroglyphs shift  38 */
/* State 4 */
  {YYNOCODE,0,0}, /* Unused */
/* State 5 */
  {YYNOCODE,0,0}, /* Unused */
/* State 6 */
  {YYNOCODE,0,0}, /* Unused */
/* State 7 */
  {YYNOCODE,0,0}, /* Unused */
/* State 8 */
  {YYNOCODE,0,0}, /* Unused */
/* State 9 */
  {YYNOCODE,0,0}, /* Unused */
/* State 10 */
  {YYNOCODE,0,0}, /* Unused */
/* State 11 */
  {YYNOCODE,0,0}, /* Unused */
/* State 12 */
  {  42,  13, 0                    }, /*             optShading shift  13 */
  {  17,  14, 0                    }, /*                SHADING shift  14 */
/* State 13 */
  {YYNOCODE,0,0}, /* Unused */
/* State 14 */
  {YYNOCODE,0,0}, /* Unused */
/* State 15 */
  {   6,  16, 0                    }, /*                 COLUMN shift  16 */
/* State 16 */
  {  32,  35, 0                    }, /*    hieroglyphsOrSymbol shift  35 */
  {  33,  24, 0                    }, /*             inhierlist shift  24 */
  {  34,  18, 0                    }, /*            inhierlists shift  18 */
  {  35,  49, &yyActionTable[  72] }, /*              ligatures shift  49 */
  {   4,  22, 0                    }, /*              BEGINPHIL shift  22 */
  {   5,  27, 0                    }, /*                   BPAR shift  27 */
  {  19,  48, 0                    }, /*                 SYMBOL shift  48 */
  {YYNOCODE,0,0}, /* Unused */
  {  40,  41, 0                    }, /*             optGrammar shift  41 */
  {YYNOCODE,0,0}, /* Unused */
  {  10,  47, 0                    }, /*                GRAMMAR shift  47 */
  {  11, 106, 0                    }, /*             HIEROGLYPH reduce 42 */
  {  28,  21, 0                    }, /*            complexsign shift  21 */
  {  45,  17, 0                    }, /*              subcadrat shift  17 */
  {  30,  50, 0                    }, /*             hieroglyph shift  50 */
  {  31,  38, 0                    }, /*            hieroglyphs shift  38 */
/* State 17 */
  {YYNOCODE,0,0}, /* Unused */
/* State 18 */
  {  18,  19, 0                    }, /*                   STAR shift  19 */
/* State 19 */
  {  32,  35, 0                    }, /*    hieroglyphsOrSymbol shift  35 */
  {  33,  20, 0                    }, /*             inhierlist shift  20 */
  {  19,  48, 0                    }, /*                 SYMBOL shift  48 */
  {  35,  49, &yyActionTable[  86] }, /*              ligatures shift  49 */
  {   4,  22, 0                    }, /*              BEGINPHIL shift  22 */
  {   5,  27, 0                    }, /*                   BPAR shift  27 */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {  40,  41, 0                    }, /*             optGrammar shift  41 */
  {YYNOCODE,0,0}, /* Unused */
  {  10,  47, 0                    }, /*                GRAMMAR shift  47 */
  {  11, 106, 0                    }, /*             HIEROGLYPH reduce 42 */
  {  28,  21, 0                    }, /*            complexsign shift  21 */
  {YYNOCODE,0,0}, /* Unused */
  {  30,  50, 0                    }, /*             hieroglyph shift  50 */
  {  31,  38, 0                    }, /*            hieroglyphs shift  38 */
/* State 20 */
  {YYNOCODE,0,0}, /* Unused */
/* State 21 */
  {YYNOCODE,0,0}, /* Unused */
/* State 22 */
  {  32,  35, 0                    }, /*    hieroglyphsOrSymbol shift  35 */
  {  33,  24, 0                    }, /*             inhierlist shift  24 */
  {  34,  18, 0                    }, /*            inhierlists shift  18 */
  {  35,  49, 0                    }, /*              ligatures shift  49 */
  {  36,  52, &yyActionTable[ 108] }, /*             maincadrat shift  52 */
  {  37,  30, &yyActionTable[ 109] }, /*            maincadrats shift  30 */
  {   4,  22, 0                    }, /*              BEGINPHIL shift  22 */
  {   5,  27, 0                    }, /*                   BPAR shift  27 */
  {  40,  41, 0                    }, /*             optGrammar shift  41 */
  {YYNOCODE,0,0}, /* Unused */
  {  10,  47, 0                    }, /*                GRAMMAR shift  47 */
  {  11, 106, 0                    }, /*             HIEROGLYPH reduce 42 */
  {YYNOCODE,0,0}, /* Unused */
  {  45,  23, 0                    }, /*              subcadrat shift  23 */
  {  46,  15, 0                    }, /*             subcadrats shift  15 */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {  19,  48, 0                    }, /*                 SYMBOL shift  48 */
  {  20,  34, 0                    }, /*                   TEXT shift  34 */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {  24,  33, 0                    }, /*                 cadrat shift  33 */
  {  25,  25, 0                    }, /*                cadrats shift  25 */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {  28,  21, 0                    }, /*            complexsign shift  21 */
  {YYNOCODE,0,0}, /* Unused */
  {  30,  50, 0                    }, /*             hieroglyph shift  50 */
  {  31,  38, 0                    }, /*            hieroglyphs shift  38 */
/* State 23 */
  {YYNOCODE,0,0}, /* Unused */
/* State 24 */
  {YYNOCODE,0,0}, /* Unused */
/* State 25 */
  {   8,  26, 0                    }, /*                ENDPHIL shift  26 */
/* State 26 */
  {YYNOCODE,0,0}, /* Unused */
/* State 27 */
  {  32,  35, 0                    }, /*    hieroglyphsOrSymbol shift  35 */
  {  33,  24, 0                    }, /*             inhierlist shift  24 */
  {  34,  18, 0                    }, /*            inhierlists shift  18 */
  {  35,  49, 0                    }, /*              ligatures shift  49 */
  {  36,  52, &yyActionTable[ 144] }, /*             maincadrat shift  52 */
  {  37,  30, &yyActionTable[ 145] }, /*            maincadrats shift  30 */
  {   4,  22, 0                    }, /*              BEGINPHIL shift  22 */
  {   5,  27, 0                    }, /*                   BPAR shift  27 */
  {  40,  41, 0                    }, /*             optGrammar shift  41 */
  {YYNOCODE,0,0}, /* Unused */
  {  10,  47, 0                    }, /*                GRAMMAR shift  47 */
  {  11, 106, 0                    }, /*             HIEROGLYPH reduce 42 */
  {YYNOCODE,0,0}, /* Unused */
  {  45,  23, 0                    }, /*              subcadrat shift  23 */
  {  46,  15, 0                    }, /*             subcadrats shift  15 */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {  19,  48, 0                    }, /*                 SYMBOL shift  48 */
  {  20,  34, 0                    }, /*                   TEXT shift  34 */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {  24,  33, 0                    }, /*                 cadrat shift  33 */
  {  25,  28, 0                    }, /*                cadrats shift  28 */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {  28,  21, 0                    }, /*            complexsign shift  21 */
  {YYNOCODE,0,0}, /* Unused */
  {  30,  50, 0                    }, /*             hieroglyph shift  50 */
  {  31,  38, 0                    }, /*            hieroglyphs shift  38 */
/* State 28 */
  {   9,  29, 0                    }, /*                   EPAR shift  29 */
/* State 29 */
  {YYNOCODE,0,0}, /* Unused */
/* State 30 */
  {  16,  51, 0                    }, /*              SEPARATOR shift  51 */
  {   4,  92, 0                    }, /*              BEGINPHIL reduce 28 */
  {   9,  89, 0                    }, /*                   EPAR reduce 25 */
  {  19,  92, 0                    }, /*                 SYMBOL reduce 28 */
  {  20,  92, &yyActionTable[ 173] }, /*                   TEXT reduce 28 */
  {   5,  92, 0                    }, /*                   BPAR reduce 28 */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {   8,  89, 0                    }, /*                ENDPHIL reduce 25 */
  {  41,  31, &yyActionTable[ 174] }, /*           optSeparator shift  31 */
  {  10,  92, 0                    }, /*                GRAMMAR reduce 28 */
  {  11,  92, 0                    }, /*             HIEROGLYPH reduce 28 */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
/* State 31 */
  {  32,  35, 0                    }, /*    hieroglyphsOrSymbol shift  35 */
  {  33,  24, 0                    }, /*             inhierlist shift  24 */
  {  34,  18, 0                    }, /*            inhierlists shift  18 */
  {  35,  49, 0                    }, /*              ligatures shift  49 */
  {  36,  32, &yyActionTable[ 194] }, /*             maincadrat shift  32 */
  {   5,  27, 0                    }, /*                   BPAR shift  27 */
  {   4,  22, 0                    }, /*              BEGINPHIL shift  22 */
  {YYNOCODE,0,0}, /* Unused */
  {  40,  41, 0                    }, /*             optGrammar shift  41 */
  {YYNOCODE,0,0}, /* Unused */
  {  10,  47, 0                    }, /*                GRAMMAR shift  47 */
  {  11, 106, 0                    }, /*             HIEROGLYPH reduce 42 */
  {YYNOCODE,0,0}, /* Unused */
  {  45,  23, 0                    }, /*              subcadrat shift  23 */
  {  46,  15, 0                    }, /*             subcadrats shift  15 */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {  19,  48, 0                    }, /*                 SYMBOL shift  48 */
  {  20,  34, 0                    }, /*                   TEXT shift  34 */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {  24,  33, 0                    }, /*                 cadrat shift  33 */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {  28,  21, 0                    }, /*            complexsign shift  21 */
  {YYNOCODE,0,0}, /* Unused */
  {  30,  50, 0                    }, /*             hieroglyph shift  50 */
  {  31,  38, 0                    }, /*            hieroglyphs shift  38 */
/* State 32 */
  {YYNOCODE,0,0}, /* Unused */
/* State 33 */
  {YYNOCODE,0,0}, /* Unused */
/* State 34 */
  {YYNOCODE,0,0}, /* Unused */
/* State 35 */
  {  14,  36, 0                    }, /*              OVERWRITE shift  36 */
/* State 36 */
  {  40,  41, &yyActionTable[ 225] }, /*             optGrammar shift  41 */
  {  32,  37, 0                    }, /*    hieroglyphsOrSymbol shift  37 */
  {  10,  47, 0                    }, /*                GRAMMAR shift  47 */
  {  35,  49, &yyActionTable[ 228] }, /*              ligatures shift  49 */
  {  19,  48, &yyActionTable[ 229] }, /*                 SYMBOL shift  48 */
  {  11, 106, 0                    }, /*             HIEROGLYPH reduce 42 */
  {  30,  50, 0                    }, /*             hieroglyph shift  50 */
  {  31,  38, 0                    }, /*            hieroglyphs shift  38 */
/* State 37 */
  {YYNOCODE,0,0}, /* Unused */
/* State 38 */
  {   1,  39, 0                    }, /*                    AMP shift  39 */
/* State 39 */
  {  40,  41, 0                    }, /*             optGrammar shift  41 */
  {  10,  47, 0                    }, /*                GRAMMAR shift  47 */
  {  30,  40, &yyActionTable[ 235] }, /*             hieroglyph shift  40 */
  {  11, 106, 0                    }, /*             HIEROGLYPH reduce 42 */
/* State 40 */
  {YYNOCODE,0,0}, /* Unused */
/* State 41 */
  {  11,  42, 0                    }, /*             HIEROGLYPH shift  42 */
/* State 42 */
  {  39,  43, 0                    }, /*              modifiers shift  43 */
/* State 43 */
  {  23,  45, 0                    }, /*                WORDEND shift  45 */
  {  13,  46, 0                    }, /*               MODIFIER shift  46 */
  {YYNOCODE,0,0}, /* Unused */
  {  43,  44, &yyActionTable[ 241] }, /*             optWordEnd shift  44 */
/* State 44 */
  {YYNOCODE,0,0}, /* Unused */
/* State 45 */
  {YYNOCODE,0,0}, /* Unused */
/* State 46 */
  {YYNOCODE,0,0}, /* Unused */
/* State 47 */
  {  11, 107, 0                    }, /*             HIEROGLYPH reduce 43 */
/* State 48 */
  {YYNOCODE,0,0}, /* Unused */
/* State 49 */
  {YYNOCODE,0,0}, /* Unused */
/* State 50 */
  {YYNOCODE,0,0}, /* Unused */
/* State 51 */
  {YYNOCODE,0,0}, /* Unused */
/* State 52 */
  {YYNOCODE,0,0}, /* Unused */
/* State 53 */
  {  27,  54, 0                    }, /*         cartoucheTexts shift  54 */
/* State 54 */
  {  32,  35, 0                    }, /*    hieroglyphsOrSymbol shift  35 */
  {  33,  24, 0                    }, /*             inhierlist shift  24 */
  {  34,  18, 0                    }, /*            inhierlists shift  18 */
  {  35,  49, 0                    }, /*              ligatures shift  49 */
  {   4,  22, 0                    }, /*              BEGINPHIL shift  22 */
  {   5,  27, 0                    }, /*                   BPAR shift  27 */
  {YYNOCODE,0,0}, /* Unused */
  {   7,  55, 0                    }, /*           ENDCARTOUCHE shift  55 */
  {  40,  41, 0                    }, /*             optGrammar shift  41 */
  {YYNOCODE,0,0}, /* Unused */
  {  10,  47, 0                    }, /*                GRAMMAR shift  47 */
  {  11, 106, 0                    }, /*             HIEROGLYPH reduce 42 */
  {YYNOCODE,0,0}, /* Unused */
  {  45,  23, 0                    }, /*              subcadrat shift  23 */
  {  46,  15, 0                    }, /*             subcadrats shift  15 */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {  49,  56, 0                    }, /*              topcadrat shift  56 */
  {YYNOCODE,0,0}, /* Unused */
  {  19,  48, 0                    }, /*                 SYMBOL shift  48 */
  {  20,  57, 0                    }, /*                   TEXT shift  57 */
  {YYNOCODE,0,0}, /* Unused */
  {  22,  58, 0                    }, /*                 TOGGLE shift  58 */
  {YYNOCODE,0,0}, /* Unused */
  {  24,  12, 0                    }, /*                 cadrat shift  12 */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {  28,  21, 0                    }, /*            complexsign shift  21 */
  {YYNOCODE,0,0}, /* Unused */
  {  30,  50, 0                    }, /*             hieroglyph shift  50 */
  {  31,  38, 0                    }, /*            hieroglyphs shift  38 */
/* State 55 */
  {YYNOCODE,0,0}, /* Unused */
/* State 56 */
  {YYNOCODE,0,0}, /* Unused */
/* State 57 */
  {YYNOCODE,0,0}, /* Unused */
/* State 58 */
  {YYNOCODE,0,0}, /* Unused */
/* State 59 */
  {  27,  60, 0                    }, /*         cartoucheTexts shift  60 */
/* State 60 */
  {  32,  35, 0                    }, /*    hieroglyphsOrSymbol shift  35 */
  {  33,  24, 0                    }, /*             inhierlist shift  24 */
  {  34,  18, 0                    }, /*            inhierlists shift  18 */
  {  35,  49, 0                    }, /*              ligatures shift  49 */
  {   4,  22, 0                    }, /*              BEGINPHIL shift  22 */
  {   5,  27, 0                    }, /*                   BPAR shift  27 */
  {YYNOCODE,0,0}, /* Unused */
  {   7,  61, 0                    }, /*           ENDCARTOUCHE shift  61 */
  {  40,  41, 0                    }, /*             optGrammar shift  41 */
  {YYNOCODE,0,0}, /* Unused */
  {  10,  47, 0                    }, /*                GRAMMAR shift  47 */
  {  11, 106, 0                    }, /*             HIEROGLYPH reduce 42 */
  {YYNOCODE,0,0}, /* Unused */
  {  45,  23, 0                    }, /*              subcadrat shift  23 */
  {  46,  15, 0                    }, /*             subcadrats shift  15 */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {  49,  56, 0                    }, /*              topcadrat shift  56 */
  {YYNOCODE,0,0}, /* Unused */
  {  19,  48, 0                    }, /*                 SYMBOL shift  48 */
  {  20,  57, 0                    }, /*                   TEXT shift  57 */
  {YYNOCODE,0,0}, /* Unused */
  {  22,  58, 0                    }, /*                 TOGGLE shift  58 */
  {YYNOCODE,0,0}, /* Unused */
  {  24,  12, 0                    }, /*                 cadrat shift  12 */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {  28,  21, 0                    }, /*            complexsign shift  21 */
  {YYNOCODE,0,0}, /* Unused */
  {  30,  50, 0                    }, /*             hieroglyph shift  50 */
  {  31,  38, 0                    }, /*            hieroglyphs shift  38 */
/* State 61 */
  {YYNOCODE,0,0}, /* Unused */
/* State 62 */
  {   0,  65, 0                    }, /*                      $ reduce 1 */
/* State 63 */
  {YYNOCODE,0,0}, /* Unused */
};

/* The state table contains information needed to look up the correct
** action in the action table, given the current state of the parser.
** Information needed includes:
**
**  +  A pointer to the start of the action hash table in yyActionTable.
**
**  +  A mask used to hash the look-ahead token.  The mask is an integer
**     which is one less than the size of the hash table.  
**
**  +  The default action.  This is the action to take if no entry for
**     the given look-ahead is found in the action hash table.
*/
struct yyStateEntry {
  struct yyActionEntry *hashtbl; /* Start of the hash table in yyActionTable */
  int mask;                      /* Mask used for hashing the look-ahead */
  YYACTIONTYPE actionDefault;    /* Default action if look-ahead not found */
};
static struct yyStateEntry yyStateTable[] = {
  { &yyActionTable[0], 3, 67},
  { &yyActionTable[4], 0, 68},
  { &yyActionTable[5], 15, 116},
  { &yyActionTable[21], 31, 116},
  { &yyActionTable[53], 0, 69},
  { &yyActionTable[54], 0, 70},
  { &yyActionTable[55], 0, 71},
  { &yyActionTable[56], 0, 72},
  { &yyActionTable[57], 0, 73},
  { &yyActionTable[58], 0, 74},
  { &yyActionTable[59], 0, 75},
  { &yyActionTable[60], 0, 76},
  { &yyActionTable[61], 1, 78},
  { &yyActionTable[63], 0, 77},
  { &yyActionTable[64], 0, 79},
  { &yyActionTable[65], 0, 80},
  { &yyActionTable[66], 15, 116},
  { &yyActionTable[82], 0, 82},
  { &yyActionTable[83], 0, 83},
  { &yyActionTable[84], 15, 116},
  { &yyActionTable[100], 0, 85},
  { &yyActionTable[101], 0, 86},
  { &yyActionTable[102], 31, 116},
  { &yyActionTable[134], 0, 81},
  { &yyActionTable[135], 0, 84},
  { &yyActionTable[136], 0, 116},
  { &yyActionTable[137], 0, 87},
  { &yyActionTable[138], 31, 116},
  { &yyActionTable[170], 0, 116},
  { &yyActionTable[171], 0, 88},
  { &yyActionTable[172], 15, 116},
  { &yyActionTable[188], 31, 116},
  { &yyActionTable[220], 0, 91},
  { &yyActionTable[221], 0, 94},
  { &yyActionTable[222], 0, 95},
  { &yyActionTable[223], 0, 96},
  { &yyActionTable[224], 7, 116},
  { &yyActionTable[232], 0, 97},
  { &yyActionTable[233], 0, 98},
  { &yyActionTable[234], 3, 116},
  { &yyActionTable[238], 0, 102},
  { &yyActionTable[239], 0, 116},
  { &yyActionTable[240], 0, 108},
  { &yyActionTable[241], 3, 104},
  { &yyActionTable[245], 0, 103},
  { &yyActionTable[246], 0, 105},
  { &yyActionTable[247], 0, 109},
  { &yyActionTable[248], 0, 116},
  { &yyActionTable[249], 0, 99},
  { &yyActionTable[250], 0, 100},
  { &yyActionTable[251], 0, 101},
  { &yyActionTable[252], 0, 93},
  { &yyActionTable[253], 0, 90},
  { &yyActionTable[254], 0, 112},
  { &yyActionTable[255], 31, 116},
  { &yyActionTable[287], 0, 110},
  { &yyActionTable[288], 0, 113},
  { &yyActionTable[289], 0, 114},
  { &yyActionTable[290], 0, 115},
  { &yyActionTable[291], 0, 112},
  { &yyActionTable[292], 31, 116},
  { &yyActionTable[324], 0, 111},
  { &yyActionTable[325], 0, 116},
  { &yyActionTable[326], 0, 66},
};

/* The following structure represents a single element of the
** parser's stack.  Information stored includes:
**
**   +  The state number for the parser at this level of the stack.
**
**   +  The value of the token stored at this level of the stack.
**      (In other words, the "major" token.)
**
**   +  The semantic value stored at this level of the stack.  This is
**      the information used by the action routines in the grammar.
**      It is sometimes called the "minor" token.
*/
struct yyStackEntry {
  int stateno;       /* The state-number */
  int major;         /* The major token value.  This is the code
                     ** number for the token at this stack level */
  YYMINORTYPE minor; /* The user-supplied minor token value.  This
                     ** is the value of the token  */
};

/* The state of the parser is completely contained in an instance of
** the following structure */
struct yyParser {
  int idx;                            /* Index of top element in stack */
  int errcnt;                         /* Shifts left before out of the error */
  struct yyStackEntry *top;           /* Pointer to the top stack element */
  struct yyStackEntry stack[YYSTACKDEPTH];  /* The parser's stack */
};
typedef struct yyParser yyParser;

#ifndef NDEBUG
#include <stdio.h>
static FILE *yyTraceFILE = 0;
static char *yyTracePrompt = 0;

/* 
** Turn parser tracing on by giving a stream to which to write the trace
** and a prompt to preface each trace message.  Tracing is turned off
** by making either argument NULL 
**
** Inputs:
** <ul>
** <li> A FILE* to which trace output should be written.
**      If NULL, then tracing is turned off.
** <li> A prefix string written at the beginning of every
**      line of trace output.  If NULL, then tracing is
**      turned off.
** </ul>
**
** Outputs:
** None.
*/
void ParseTrace(FILE *TraceFILE, char *zTracePrompt){
  yyTraceFILE = TraceFILE;
  yyTracePrompt = zTracePrompt;
  if( yyTraceFILE==0 ) yyTracePrompt = 0;
  else if( yyTracePrompt==0 ) yyTraceFILE = 0;
}

/* For tracing shifts, the names of all terminals and nonterminals
** are required.  The following table supplies these names */
static char *yyTokenName[] = { 
  "$",             "AMP",           "BEGINCARTOUCHE",  "BEGINOLDCARTOUCHE",
  "BEGINPHIL",     "BPAR",          "COLUMN",        "ENDCARTOUCHE",
  "ENDPHIL",       "EPAR",          "GRAMMAR",       "HIEROGLYPH",  
  "LINEEND",       "MODIFIER",      "OVERWRITE",     "PAGEEND",     
  "SEPARATOR",     "SHADING",       "STAR",          "SYMBOL",      
  "TEXT",          "TEXTSUPER",     "TOGGLE",        "WORDEND",     
  "cadrat",        "cadrats",       "cartouche",     "cartoucheTexts",
  "complexsign",   "error",         "hieroglyph",    "hieroglyphs", 
  "hieroglyphsOrSymbol",  "inhierlist",    "inhierlists",   "ligatures",   
  "maincadrat",    "maincadrats",   "mdcfile",       "modifiers",   
  "optGrammar",    "optSeparator",  "optShading",    "optWordEnd",  
  "startingGarbage",  "subcadrat",     "subcadrats",    "textitem",    
  "textitems",     "topcadrat",   
};
#define YYTRACE(X) if( yyTraceFILE ) fprintf(yyTraceFILE,"%sReduce [%s].\n",yyTracePrompt,X);
#else
#define YYTRACE(X)
#endif


/*
** This function returns the symbolic name associated with a token
** value.
*/
const char *ParseTokenName(int tokenType){
#ifndef NDEBUG
  if( tokenType>0 && tokenType<(sizeof(yyTokenName)/sizeof(yyTokenName[0])) ){
    return yyTokenName[tokenType];
  }else{
    return "Unknown";
  }
#else
  return "";
#endif
}

/* 
** This function allocates a new parser.
** The only argument is a pointer to a function which works like
** malloc.
**
** Inputs:
** A pointer to the function used to allocate memory.
**
** Outputs:
** A pointer to a parser.  This pointer is used in subsequent calls
** to Parse and ParseFree.
*/
void *ParseAlloc(void *(*mallocProc)(int)){
  yyParser *pParser;
  pParser = (yyParser*)(*mallocProc)( (int)sizeof(yyParser) );
  if( pParser ){
    pParser->idx = -1;
  }
  return pParser;
}

/* The following function deletes the value associated with a
** symbol.  The symbol can be either a terminal or nonterminal.
** "yymajor" is the symbol code, and "yypminor" is a pointer to
** the value.
*/
static void yy_destructor(YYCODETYPE yymajor, YYMINORTYPE *yypminor){
  switch( yymajor ){
    /* Here is inserted the actions which take place when a
    ** terminal or non-terminal is destroyed.  This can happen
    ** when the symbol is popped from the stack during a
    ** reduce or during error processing or when a parser is 
    ** being destroyed before it is finished parsing.
    **
    ** Note: during a reduce, the only symbols destroyed are those
    ** which appear on the RHS of the rule, but which are not used
    ** inside the C code.
    */
    default:  break;   /* If no destructor action specified: do nothing */
  }
}

/*
** Pop the parser's stack once.
**
** If there is a destructor routine associated with the token which
** is popped from the stack, then call it.
**
** Return the major token number for the symbol popped.
*/
static int yy_pop_parser_stack(yyParser *pParser){
  YYCODETYPE yymajor;

  if( pParser->idx<0 ) return 0;
#ifndef NDEBUG
  if( yyTraceFILE && pParser->idx>=0 ){
    fprintf(yyTraceFILE,"%sPopping %s\n",
      yyTracePrompt,
      yyTokenName[pParser->top->major]);
  }
#endif
  yymajor = pParser->top->major;
  yy_destructor( yymajor, &pParser->top->minor);
  pParser->idx--;
  pParser->top--;
  return yymajor;
}

/* 
** Deallocate and destroy a parser.  Destructors are all called for
** all stack elements before shutting the parser down.
**
** Inputs:
** <ul>
** <li>  A pointer to the parser.  This should be a pointer
**       obtained from ParseAlloc.
** <li>  A pointer to a function used to reclaim memory obtained
**       from malloc.
** </ul>
*/
void ParseFree(
  void *p,                    /* The parser to be deleted */
  void (*freeProc)(void*)     /* Function used to reclaim memory */
){
  yyParser *pParser = (yyParser*)p;
  if( pParser==0 ) return;
  while( pParser->idx>=0 ) yy_pop_parser_stack(pParser);
  (*freeProc)((void*)pParser);
}

/*
** Find the appropriate action for a parser given the look-ahead token.
**
** If the look-ahead token is YYNOCODE, then check to see if the action is
** independent of the look-ahead.  If it is, return the action, otherwise
** return YY_NO_ACTION.
*/
static int yy_find_parser_action(
  yyParser *pParser,        /* The parser */
  int iLookAhead             /* The look-ahead token */
){
  struct yyStateEntry *pState;   /* Appropriate entry in the state table */
  struct yyActionEntry *pAction; /* Action appropriate for the look-ahead */
 
  /* if( pParser->idx<0 ) return YY_NO_ACTION;  */
  pState = &yyStateTable[pParser->top->stateno];
  if( iLookAhead!=YYNOCODE ){
    pAction = &pState->hashtbl[iLookAhead & pState->mask];
    while( pAction ){
      if( pAction->lookahead==iLookAhead ) return pAction->action;
      pAction = pAction->next;
    }
  }else if( pState->mask!=0 || pState->hashtbl->lookahead!=YYNOCODE ){
    return YY_NO_ACTION;
  }
  return pState->actionDefault;
}

/*
** Perform a shift action.
*/
static void yy_shift(
  yyParser *yypParser,          /* The parser to be shifted */
  int yyNewState,               /* The new state to shift in */
  int yyMajor,                  /* The major token to shift in */
  YYMINORTYPE *yypMinor         /* Pointer ot the minor token to shift in */
){
  yypParser->idx++;
  yypParser->top++;
  if( yypParser->idx>=YYSTACKDEPTH ){
     yypParser->idx--;
     yypParser->top--;
#ifndef NDEBUG
     if( yyTraceFILE ){
       fprintf(yyTraceFILE,"%sStack Overflow!\n",yyTracePrompt);
     }
#endif
     while( yypParser->idx>=0 ) yy_pop_parser_stack(yypParser);
     /* Here code is inserted which will execute if the parser
     ** stack every overflows */
     return;
  }
  yypParser->top->stateno = yyNewState;
  yypParser->top->major = yyMajor;
  yypParser->top->minor = *yypMinor;
#ifndef NDEBUG
  if( yyTraceFILE && yypParser->idx>0 ){
    int i;
    fprintf(yyTraceFILE,"%sShift %d\n",yyTracePrompt,yyNewState);
    fprintf(yyTraceFILE,"%sStack:",yyTracePrompt);
    for(i=1; i<=yypParser->idx; i++)
      fprintf(yyTraceFILE," %s",yyTokenName[yypParser->stack[i].major]);
    fprintf(yyTraceFILE,"\n");
  }
#endif
}

/* The following table contains information about every rule that
** is used during the reduce.
*/
static struct {
  YYCODETYPE lhs;         /* Symbol on the left-hand side of the rule */
  unsigned char nrhs;     /* Number of right-hand side symbols in the rule */
} yyRuleInfo[] = {
  { 38, 2 },
  { 38, 1 },
  { 44, 1 },
  { 44, 0 },
  { 48, 0 },
  { 48, 3 },
  { 47, 1 },
  { 47, 1 },
  { 47, 1 },
  { 47, 1 },
  { 47, 1 },
  { 47, 1 },
  { 47, 1 },
  { 49, 2 },
  { 42, 0 },
  { 42, 1 },
  { 24, 1 },
  { 46, 1 },
  { 46, 3 },
  { 45, 1 },
  { 34, 1 },
  { 34, 3 },
  { 33, 1 },
  { 33, 3 },
  { 33, 3 },
  { 25, 1 },
  { 37, 1 },
  { 37, 3 },
  { 41, 0 },
  { 41, 1 },
  { 36, 1 },
  { 36, 1 },
  { 28, 1 },
  { 28, 3 },
  { 32, 1 },
  { 32, 1 },
  { 31, 1 },
  { 35, 1 },
  { 35, 3 },
  { 30, 4 },
  { 43, 0 },
  { 43, 1 },
  { 40, 0 },
  { 40, 1 },
  { 39, 0 },
  { 39, 2 },
  { 26, 3 },
  { 26, 3 },
  { 27, 0 },
  { 27, 2 },
  { 27, 2 },
  { 27, 2 },
};

static void yy_accept(yyParser *  ParseANSIARGDECL);  /* Forward Declaration */

/*
** Perform a reduce action and the shift that must immediately
** follow the reduce.
*/
static void yy_reduce(
  yyParser *yypParser,         /* The parser */
  int yyruleno                 /* Number of the rule by which to reduce */
  ParseANSIARGDECL
){
  int yygoto;                     /* The next state */
  int yyact;                      /* The next action */
  YYMINORTYPE yygotominor;        /* The LHS of the rule reduced */
  struct yyStackEntry *yymsp;     /* The top of the parser's stack */
  int yysize;                     /* Amount to pop the stack */
  yymsp = yypParser->top;
  switch( yyruleno ){
  /* Beginning here are the reduction cases.  A typical example
  ** follows:
  **   case 0:
  **     YYTRACE("<text of the rule>");
  **  #line <lineno> <grammarfile>
  **     { ... }           // User supplied code
  **  #line <lineno> <thisfile>
  **     break;
  */
      case 0:
        YYTRACE("mdcfile ::= startingGarbage textitems")
#line 60 "mdcTclParse.y"
{yygotominor.yy0= yymsp[0].minor.yy0;}
#line 955 "mdcTclParse.c"
        /* No destructor defined for startingGarbage */
        break;
      case 1:
        YYTRACE("mdcfile ::= error")
#line 61 "mdcTclParse.y"
{yygotominor.yy0= NULL;}
#line 962 "mdcTclParse.c"
        /* No destructor defined for error */
        break;
      case 2:
        YYTRACE("startingGarbage ::= WORDEND")
        /* No destructor defined for WORDEND */
        break;
      case 3:
        YYTRACE("startingGarbage ::=")
        break;
      case 4:
        YYTRACE("textitems ::=")
#line 66 "mdcTclParse.y"
{yygotominor.yy0= Tcl_NewListObj(0,0);}
#line 976 "mdcTclParse.c"
        break;
      case 5:
        YYTRACE("textitems ::= textitems optSeparator textitem")
#line 67 "mdcTclParse.y"
{
	Tcl_ListObjAppendElement(context->interp, yymsp[-2].minor.yy0, yymsp[0].minor.yy0);
	yygotominor.yy0= yymsp[-2].minor.yy0;
}
#line 985 "mdcTclParse.c"
        /* No destructor defined for optSeparator */
        break;
      case 6:
        YYTRACE("textitem ::= topcadrat")
#line 75 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 994 "mdcTclParse.c"
        break;
      case 7:
        YYTRACE("textitem ::= cartouche")
#line 79 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 1002 "mdcTclParse.c"
        break;
      case 8:
        YYTRACE("textitem ::= LINEEND")
#line 83 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 1010 "mdcTclParse.c"
        break;
      case 9:
        YYTRACE("textitem ::= PAGEEND")
#line 87 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 1018 "mdcTclParse.c"
        break;
      case 10:
        YYTRACE("textitem ::= TEXTSUPER")
#line 91 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 1026 "mdcTclParse.c"
        break;
      case 11:
        YYTRACE("textitem ::= TOGGLE")
#line 95 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 1034 "mdcTclParse.c"
        break;
      case 12:
        YYTRACE("textitem ::= TEXT")
#line 99 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 1042 "mdcTclParse.c"
        break;
      case 13:
        YYTRACE("topcadrat ::= cadrat optShading")
#line 105 "mdcTclParse.y"
{
	/* Format for cadrat : {c DATA ?opt1 val1? ?opt2 val2?} */
	/* so we simply append shading : */
	Tcl_ListObjAppendList(context->interp, yymsp[-1].minor.yy0, yymsp[0].minor.yy0);
	yygotominor.yy0= yymsp[-1].minor.yy0;
}
#line 1053 "mdcTclParse.c"
        break;
      case 14:
        YYTRACE("optShading ::=")
#line 112 "mdcTclParse.y"
{	yygotominor.yy0= Tcl_NewListObj(0,0);
}
#line 1060 "mdcTclParse.c"
        break;
      case 15:
        YYTRACE("optShading ::= SHADING")
#line 115 "mdcTclParse.y"
{
	/*
	 * Shading is a integer :
	 * 1 means first quarter is shaded
	 * 2 means second quarter is shaded
	 * 4 means third quarter is shaded
	 * 8 means fourth quarter is shaded
	 *
	 * combining these is done by adding the corresponding values.
	 * 
	 * Thus, if both first, second and fourth quarters are shaded,
	 * shading's value will be 1+2+8= 11
	 */
	yygotominor.yy0= Tksesh_NewTclCouple(Tksesh_NewTclKeyword("shading"), yymsp[0].minor.yy0);
}
#line 1080 "mdcTclParse.c"
        break;
      case 16:
        YYTRACE("cadrat ::= subcadrats")
#line 133 "mdcTclParse.y"
{
	yygotominor.yy0= Tksesh_NewTclCouple(Tksesh_NewTclKeyword("c"),yymsp[0].minor.yy0);
}
#line 1088 "mdcTclParse.c"
        break;
      case 17:
        YYTRACE("subcadrats ::= subcadrat")
#line 137 "mdcTclParse.y"
{
	yygotominor.yy0= Tksesh_NewTclSingleton(yymsp[0].minor.yy0);
}
#line 1096 "mdcTclParse.c"
        break;
      case 18:
        YYTRACE("subcadrats ::= subcadrats COLUMN subcadrat")
#line 142 "mdcTclParse.y"
{
	Tcl_ListObjAppendElement(context->interp, yymsp[-2].minor.yy0, yymsp[0].minor.yy0);
	yygotominor.yy0= yymsp[-2].minor.yy0;
}
#line 1105 "mdcTclParse.c"
        /* No destructor defined for COLUMN */
        break;
      case 19:
        YYTRACE("subcadrat ::= inhierlists")
#line 150 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 1114 "mdcTclParse.c"
        break;
      case 20:
        YYTRACE("inhierlists ::= inhierlist")
#line 155 "mdcTclParse.y"
{
	yygotominor.yy0= Tksesh_NewTclSingleton(yymsp[0].minor.yy0);
}
#line 1122 "mdcTclParse.c"
        break;
      case 21:
        YYTRACE("inhierlists ::= inhierlists STAR inhierlist")
#line 160 "mdcTclParse.y"
{
	Tcl_ListObjAppendElement(context->interp, yymsp[-2].minor.yy0, yymsp[0].minor.yy0);
	yygotominor.yy0= yymsp[-2].minor.yy0;
}
#line 1131 "mdcTclParse.c"
        /* No destructor defined for STAR */
        break;
      case 22:
        YYTRACE("inhierlist ::= complexsign")
#line 168 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 1140 "mdcTclParse.c"
        break;
      case 23:
        YYTRACE("inhierlist ::= BEGINPHIL cadrats ENDPHIL")
#line 173 "mdcTclParse.y"
{	
		yygotominor.yy0= Tksesh_NewTclCouple(Tksesh_NewTclKeyword("philology"),yymsp[-1].minor.yy0);
		yygotominor.yy0= yymsp[-2].minor.yy0;
		yygotominor.yy0= yymsp[0].minor.yy0;
	/* Now, compute and add information about what kind of philological
     comments we have : TO DO */
	
}
#line 1153 "mdcTclParse.c"
        break;
      case 24:
        YYTRACE("inhierlist ::= BPAR cadrats EPAR")
#line 183 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[-1].minor.yy0;
}
#line 1161 "mdcTclParse.c"
        /* No destructor defined for BPAR */
        /* No destructor defined for EPAR */
        break;
      case 25:
        YYTRACE("cadrats ::= maincadrats")
#line 190 "mdcTclParse.y"
{
	yygotominor.yy0= Tksesh_NewTclCouple(Tksesh_NewTclKeyword("subcadrat"),yymsp[0].minor.yy0);
}
#line 1171 "mdcTclParse.c"
        break;
      case 26:
        YYTRACE("maincadrats ::= maincadrat")
#line 195 "mdcTclParse.y"
{
	yygotominor.yy0= Tksesh_NewTclSingleton(yymsp[0].minor.yy0);
}
#line 1179 "mdcTclParse.c"
        break;
      case 27:
        YYTRACE("maincadrats ::= maincadrats optSeparator maincadrat")
#line 200 "mdcTclParse.y"
{
	Tcl_ListObjAppendElement(context->interp, yymsp[-2].minor.yy0, yymsp[0].minor.yy0);
	yygotominor.yy0= yymsp[-2].minor.yy0;
}
#line 1188 "mdcTclParse.c"
        /* No destructor defined for optSeparator */
        break;
      case 28:
        YYTRACE("optSeparator ::=")
        break;
      case 29:
        YYTRACE("optSeparator ::= SEPARATOR")
        /* No destructor defined for SEPARATOR */
        break;
      case 30:
        YYTRACE("maincadrat ::= cadrat")
#line 211 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 1204 "mdcTclParse.c"
        break;
      case 31:
        YYTRACE("maincadrat ::= TEXT")
#line 216 "mdcTclParse.y"
{
	yygotominor.yy0= Tksesh_NewTclCouple(Tksesh_NewTclKeyword("latin"),yymsp[0].minor.yy0);
}
#line 1212 "mdcTclParse.c"
        break;
      case 32:
        YYTRACE("complexsign ::= hieroglyphsOrSymbol")
#line 223 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 1220 "mdcTclParse.c"
        break;
      case 33:
        YYTRACE("complexsign ::= hieroglyphsOrSymbol OVERWRITE hieroglyphsOrSymbol")
#line 228 "mdcTclParse.y"
{
	yygotominor.yy0= Tksesh_NewTclTriplet(Tksesh_NewTclKeyword("overwrite"), yymsp[-2].minor.yy0, yymsp[0].minor.yy0);
}
#line 1228 "mdcTclParse.c"
        /* No destructor defined for OVERWRITE */
        break;
      case 34:
        YYTRACE("hieroglyphsOrSymbol ::= hieroglyphs")
#line 233 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 1237 "mdcTclParse.c"
        break;
      case 35:
        YYTRACE("hieroglyphsOrSymbol ::= SYMBOL")
#line 238 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 1245 "mdcTclParse.c"
        break;
      case 36:
        YYTRACE("hieroglyphs ::= ligatures")
#line 246 "mdcTclParse.y"
{
	int l;
	Tcl_ListObjLength(context->interp, yymsp[0].minor.yy0, &l);
	if (l == 1) {
		yygotominor.yy0= yymsp[0].minor.yy0;
	} else {
		yygotominor.yy0= Tksesh_NewTclCouple(Tksesh_NewTclKeyword("lig"), yymsp[0].minor.yy0);
	}
}
#line 1259 "mdcTclParse.c"
        break;
      case 37:
        YYTRACE("ligatures ::= hieroglyph")
#line 257 "mdcTclParse.y"
{
	yygotominor.yy0= Tksesh_NewTclSingleton(yymsp[0].minor.yy0);
}
#line 1267 "mdcTclParse.c"
        break;
      case 38:
        YYTRACE("ligatures ::= hieroglyphs AMP hieroglyph")
#line 262 "mdcTclParse.y"
{
	Tcl_ListObjAppendElement(context->interp, yymsp[-2].minor.yy0, yymsp[0].minor.yy0);
	yygotominor.yy0= yymsp[-2].minor.yy0;
}
#line 1276 "mdcTclParse.c"
        /* No destructor defined for AMP */
        break;
      case 39:
        YYTRACE("hieroglyph ::= optGrammar HIEROGLYPH modifiers optWordEnd")
#line 270 "mdcTclParse.y"
{
		yygotominor.yy0= Tksesh_NewTclCouple(Tksesh_NewTclKeyword("s"), yymsp[-2].minor.yy0);
		Tcl_ListObjAppendList(context->interp, yygotominor.yy0, yymsp[-1].minor.yy0);
		if (yymsp[0].minor.yy92) {
				Tcl_ListObjAppendElement(context->interp, yygotominor.yy0, 
																 Tksesh_NewTclCouple(Tksesh_NewTclKeyword("wordend"),
																										 Tcl_NewIntObj(1)));
		}
		if (yymsp[-3].minor.yy92) {
				Tcl_ListObjAppendElement(context->interp, yygotominor.yy0, 
																 Tksesh_NewTclCouple(Tksesh_NewTclKeyword("gram"),
																										 Tcl_NewIntObj(1)));
		}
}
#line 1296 "mdcTclParse.c"
        break;
      case 40:
        YYTRACE("optWordEnd ::=")
#line 286 "mdcTclParse.y"
{
	yygotominor.yy92= FALSE;
}
#line 1304 "mdcTclParse.c"
        break;
      case 41:
        YYTRACE("optWordEnd ::= WORDEND")
#line 291 "mdcTclParse.y"
{
	yygotominor.yy92= TRUE;
}
#line 1312 "mdcTclParse.c"
        /* No destructor defined for WORDEND */
        break;
      case 42:
        YYTRACE("optGrammar ::=")
#line 296 "mdcTclParse.y"
{
	yygotominor.yy92= FALSE;
}
#line 1321 "mdcTclParse.c"
        break;
      case 43:
        YYTRACE("optGrammar ::= GRAMMAR")
#line 301 "mdcTclParse.y"
{
	yygotominor.yy92= TRUE;
}
#line 1329 "mdcTclParse.c"
        /* No destructor defined for GRAMMAR */
        break;
      case 44:
        YYTRACE("modifiers ::=")
#line 306 "mdcTclParse.y"
{
	yygotominor.yy0= Tcl_NewListObj(0,0);
}
#line 1338 "mdcTclParse.c"
        break;
      case 45:
        YYTRACE("modifiers ::= modifiers MODIFIER")
#line 311 "mdcTclParse.y"
{
	Tcl_ListObjAppendElement(context->interp, yymsp[-1].minor.yy0, yymsp[0].minor.yy0);
	yygotominor.yy0= yymsp[-1].minor.yy0;
}
#line 1347 "mdcTclParse.c"
        break;
      case 46:
        YYTRACE("cartouche ::= BEGINCARTOUCHE cartoucheTexts ENDCARTOUCHE")
#line 320 "mdcTclParse.y"
{
	yygotominor.yy0= Tksesh_NewTclCouple(Tksesh_NewTclKeyword("cartouche"), yymsp[-1].minor.yy0);
}
#line 1355 "mdcTclParse.c"
        /* No destructor defined for BEGINCARTOUCHE */
        /* No destructor defined for ENDCARTOUCHE */
        break;
      case 47:
        YYTRACE("cartouche ::= BEGINOLDCARTOUCHE cartoucheTexts ENDCARTOUCHE")
#line 325 "mdcTclParse.y"
{
	yygotominor.yy0= Tksesh_NewTclCouple(Tksesh_NewTclKeyword("cartouche"), yymsp[-1].minor.yy0);
}
#line 1365 "mdcTclParse.c"
        /* No destructor defined for BEGINOLDCARTOUCHE */
        /* No destructor defined for ENDCARTOUCHE */
        break;
      case 48:
        YYTRACE("cartoucheTexts ::=")
#line 330 "mdcTclParse.y"
{
	yygotominor.yy0= Tcl_NewListObj(0,0);
}
#line 1375 "mdcTclParse.c"
        break;
      case 49:
        YYTRACE("cartoucheTexts ::= cartoucheTexts topcadrat")
#line 335 "mdcTclParse.y"
{
	Tcl_ListObjAppendElement(context->interp, yymsp[-1].minor.yy0, yymsp[0].minor.yy0);
	yygotominor.yy0= yymsp[-1].minor.yy0;
}
#line 1384 "mdcTclParse.c"
        break;
      case 50:
        YYTRACE("cartoucheTexts ::= cartoucheTexts TEXT")
#line 341 "mdcTclParse.y"
{
	Tcl_ListObjAppendElement(context->interp, yymsp[-1].minor.yy0, yymsp[0].minor.yy0);
	yygotominor.yy0= yymsp[-1].minor.yy0;
}
#line 1393 "mdcTclParse.c"
        break;
      case 51:
        YYTRACE("cartoucheTexts ::= cartoucheTexts TOGGLE")
#line 347 "mdcTclParse.y"
{
	Tcl_ListObjAppendElement(context->interp, yymsp[-1].minor.yy0, yymsp[0].minor.yy0);
	yygotominor.yy0= yymsp[-1].minor.yy0;
}
#line 1402 "mdcTclParse.c"
        break;
  };
  yygoto = yyRuleInfo[yyruleno].lhs;
  yysize = yyRuleInfo[yyruleno].nrhs;
  yypParser->idx -= yysize;
  yypParser->top -= yysize;
  yyact = yy_find_parser_action(yypParser,yygoto);
  if( yyact < YYNSTATE ){
    yy_shift(yypParser,yyact,yygoto,&yygotominor);
  }else if( yyact == YYNSTATE + YYNRULE + 1 ){
    yy_accept(yypParser ParseARGDECL);
  }
}

/*
** The following code executes when the parse fails
*/
static void yy_parse_failed(
  yyParser *yypParser           /* The parser */
  ParseANSIARGDECL              /* Extra arguments (if any) */
){
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sFail!\n",yyTracePrompt);
  }
#endif
  while( yypParser->idx>=0 ) yy_pop_parser_stack(yypParser);
  /* Here code is inserted which will be executed whenever the
  ** parser fails */
}

/*
** The following code executes when a syntax error first occurs.
*/
static void yy_syntax_error(
  yyParser *yypParser,           /* The parser */
  int yymajor,                   /* The major type of the error token */
  YYMINORTYPE yyminor            /* The minor type of the error token */
  ParseANSIARGDECL               /* Extra arguments (if any) */
){
#define TOKEN (yyminor.yy0)
}

/*
** The following is executed when the parser accepts
*/
static void yy_accept(
  yyParser *yypParser           /* The parser */
  ParseANSIARGDECL              /* Extra arguments (if any) */
){
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sAccept!\n",yyTracePrompt);
  }
#endif
  while( yypParser->idx>=0 ) yy_pop_parser_stack(yypParser);
  /* Here code is inserted which will be executed whenever the
  ** parser accepts */
}

/* The main parser program.
** The first argument is a pointer to a structure obtained from
** "ParseAlloc" which describes the current state of the parser.
** The second argument is the major token number.  The third is
** the minor token.  The fourth optional argument is whatever the
** user wants (and specified in the grammar) and is available for
** use by the action routines.
**
** Inputs:
** <ul>
** <li> A pointer to the parser (an opaque structure.)
** <li> The major token number.
** <li> The minor token number.
** <li> An option argument of a grammar-specified type.
** </ul>
**
** Outputs:
** None.
*/
void Parse(
  void *yyp,                   /* The parser */
  int yymajor,                 /* The major token code number */
  ParseTOKENTYPE yyminor       /* The value for the token */
  ParseANSIARGDECL
){
  YYMINORTYPE yyminorunion;
  int yyact;            /* The parser action. */
  int yyendofinput;     /* True if we are at the end of input */
  int yyerrorhit = 0;   /* True if yymajor has invoked an error */
  yyParser *yypParser;  /* The parser */

  /* (re)initialize the parser, if necessary */
  yypParser = (yyParser*)yyp;
  if( yypParser->idx<0 ){
    if( yymajor==0 ) return;
    yypParser->idx = 0;
    yypParser->errcnt = -1;
    yypParser->top = &yypParser->stack[0];
    yypParser->top->stateno = 0;
    yypParser->top->major = 0;
  }
  yyminorunion.yy0 = yyminor;
  yyendofinput = (yymajor==0);

#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sInput %s\n",yyTracePrompt,yyTokenName[yymajor]);
  }
#endif

  do{
    yyact = yy_find_parser_action(yypParser,yymajor);
    if( yyact<YYNSTATE ){
      yy_shift(yypParser,yyact,yymajor,&yyminorunion);
      yypParser->errcnt--;
      if( yyendofinput && yypParser->idx>=0 ){
        yymajor = 0;
      }else{
        yymajor = YYNOCODE;
      }
    }else if( yyact < YYNSTATE + YYNRULE ){
      yy_reduce(yypParser,yyact-YYNSTATE ParseARGDECL);
    }else if( yyact == YY_ERROR_ACTION ){
#ifndef NDEBUG
      if( yyTraceFILE ){
        fprintf(yyTraceFILE,"%sSyntax Error!\n",yyTracePrompt);
      }
#endif
#ifdef YYERRORSYMBOL
      /* A syntax error has occurred.
      ** The response to an error depends upon whether or not the
      ** grammar defines an error token "ERROR".  
      **
      ** This is what we do if the grammar does define ERROR:
      **
      **  * Call the %syntax_error function.
      **
      **  * Begin popping the stack until we enter a state where
      **    it is legal to shift the error symbol, then shift
      **    the error symbol.
      **
      **  * Set the error count to three.
      **
      **  * Begin accepting and shifting new tokens.  No new error
      **    processing will occur until three tokens have been
      **    shifted successfully.
      **
      */
      if( yypParser->errcnt<0 ){
        yy_syntax_error(yypParser,yymajor,yyminorunion ParseARGDECL);
      }
      if( yypParser->top->major==YYERRORSYMBOL || yyerrorhit ){
#ifndef NDEBUG
        if( yyTraceFILE ){
          fprintf(yyTraceFILE,"%sDiscard input token %s\n",
             yyTracePrompt,yyTokenName[yymajor]);
        }
#endif
        yy_destructor(yymajor,&yyminorunion);
        yymajor = YYNOCODE;
      }else{
         while(
          yypParser->idx >= 0 &&
          yypParser->top->major != YYERRORSYMBOL &&
          (yyact = yy_find_parser_action(yypParser,YYERRORSYMBOL)) >= YYNSTATE
        ){
          yy_pop_parser_stack(yypParser);
        }
        if( yypParser->idx < 0 || yymajor==0 ){
          yy_destructor(yymajor,&yyminorunion);
          yy_parse_failed(yypParser ParseARGDECL);
          yymajor = YYNOCODE;
        }else if( yypParser->top->major!=YYERRORSYMBOL ){
          YYMINORTYPE u2;
          u2.YYERRSYMDT = 0;
          yy_shift(yypParser,yyact,YYERRORSYMBOL,&u2);
        }
      }
      yypParser->errcnt = 3;
      yyerrorhit = 1;
#else  /* YYERRORSYMBOL is not defined */
      /* This is what we do if the grammar does not define ERROR:
      **
      **  * Report an error message, and throw away the input token.
      **
      **  * If the input token is $, then fail the parse.
      **
      ** As before, subsequent error messages are suppressed until
      ** three input tokens have been successfully shifted.
      */
      if( yypParser->errcnt<=0 ){
        yy_syntax_error(yypParser,yymajor,yyminorunion ParseARGDECL);
      }
      yypParser->errcnt = 3;
      yy_destructor(yymajor,&yyminorunion);
      if( yyendofinput ){
        yy_parse_failed(yypParser ParseARGDECL);
      }
      yymajor = YYNOCODE;
#endif
    }else{
      yy_accept(yypParser ParseARGDECL);
      yymajor = YYNOCODE;
    }
  }while( yymajor!=YYNOCODE && yypParser->idx>=0 );
  return;
}
#line 352 "mdcTclParse.y"



#line 1614 "mdcTclParse.c"
