%{
  /*
   *  Heavily revised version of seshl.l for the lemon based
   *  Manuel de Codage parser for TCL.
   *
   *  This parser builds a Tcl_Obj
   *
   *  Unnecessary code removed.
   */
  
#define _POSIX_SOURCE 1

#include <string.h>
#include <strings.h>
#include <stdio.h>
#include <tcl.h>
#include "../general.h"
#include "TclListUtils.h"
#include "mdcTclParse.h"

/* 
   The system to handle more than one file in yylex is
   not THAT elegant.
   to restart: yyrestart( yyin);
*/

#ifndef YY_NULL
#define YY_NULL 0
#endif

#undef YY_INPUT
#define YY_INPUT(buf,result,max_size) { result = do_array_read(buf);}

#undef YYLMAX
#define YYLMAX 10240

#define startState(x) BEGIN(x); seshLexerState.state= INITIAL;

#include "seshlcode.c"

%}

entier	([0-9]+)
INTEGER	(-?{entier})
gardiner	(([A-Z]|Aa){entier}a*)
ident	([@a-zA-Z0-9.'`]+)
ESPS	([ \t\n\015_]+)
ESPSO	([ \t\n\015_-]*)
ESP	([ \t\n\015_])
SEPSO	([\t\n\015-]*)
ROMTXT	([^+]|"+"[^lsjbict+])


%x DEFINE0 DEFINE1 HieroText COMMENTAIRE LIGNECOM
%e 2000

%%
	startState(HieroText);
                                        updateSignRead();

<HieroText>^"@GLYPH".*
<HieroText>{ident}	{
	  signWasRead();
	  setTextVal(yytext);
                                          return HIEROGLYPH;
	}

<HieroText>{ESPS}	|
<HieroText>"_"	|
<HieroText>"__"	{TLINE(); return  WORDEND;}
<HieroText>"+s"{ESPSO}	{TLINE();}
<HieroText>"="	return GRAMMAR;
<HieroText>"-"?"!="{INTEGER}"%"[\n\015 \t=-]*            |
<HieroText>"-"?"!"[\n \015\t=-]*	{
                                          TLINE();
                                          return LINEEND;
                                        }
<HieroText>"-"?"!!="{INTEGER}"%"[\n\015 \t=-]*            |
<HieroText>"-"?"!!"[\n \015\t=-]*	{
                                          TLINE();
                                          return PAGEEND;
                                        }
<HieroText>"-"{ESPSO}	{TLINE();
                                         return SEPARATOR;
                                        }
<HieroText>":"{ESPSO}	{TLINE(); return COLUMN;}
<HieroText>"*"{ESPSO}	{TLINE(); return STAR;}
<HieroText>"&"{ESPSO}	|
<HieroText>"&&"{ESPSO}	{TLINE(); return AMP;}
<HieroText>"+j"{ROMTXT}*	|
<HieroText>"+b"{ROMTXT}*	|
<HieroText>"+i"{ROMTXT}*	|
<HieroText>"+c"{ROMTXT}*	|
<HieroText>"+t"{ROMTXT}*	|
<HieroText>"+l"{ROMTXT}*	{TLINE();
	 setTextVal(dupliquechaine(yytext + 2));
	 return TEXT;
	}
<HieroText>"+dg"	{return TOGGLE;}
<HieroText>"+gd"	{return TOGGLE;}
<HieroText>"+lr"	{return TOGGLE;}
<HieroText>"+rl"	{return TOGGLE;}
<HieroText>"|"[^-]+	{ setTextVal(dupliquechaine(yytext+1));
	  return TEXTSUPER;
	}
<HieroText>\\!	;
<HieroText>{SEPSO}"."{ESPSO}	{return SYMBOL;}
<HieroText>{SEPSO}".."{ESPSO}	return POINTPOINT;
<HieroText>"//"{ESPSO}	{signe_lu= TRUE; return SHADINGG;}
<HieroText>"h/"{ESPSO}	{signe_lu= TRUE; return SHADINGH;}
<HieroText>"v/"{ESPSO}	{signe_lu= TRUE; return SHADINGV;}
<HieroText>"/"{ESPSO}	{signe_lu= TRUE; return SHADINGT;}
<HieroText>"^"{ESPSO}	return HAPLOGRAPHIE;
<HieroText>"?"{ESPSO}	return LACUNE;
<HieroText>"??"{ESPSO}	return  LIGNELACUNE;
<HieroText>"[{"{ESPSO}	{TLINE(); return DSTSUPERFETATOIRE;}
<HieroText>"}]"{ESPSO}	{TLINE(); return FSTSUPERFETATOIRE;}
<HieroText>"[["{ESPSO}	{TLINE(); return DSTEFFACE;}
<HieroText>{SEPSO}"]]"{ESPSO}	{TLINE(); return FSTEFFACE;}
<HieroText>"[\""{ESPSO}	{TLINE(); return  DSTDISPARU ;}
<HieroText>{SEPSO}"\"]"{ESPSO}	{TLINE(); return  FSTDISPARU ;}
<HieroText>"['"{ESPSO}	{TLINE(); return  DSTRAJOUTSCRIBE;}
<HieroText>{SEPSO}"']"{ESPSO}	{TLINE(); return  FSTRAJOUTSCRIBE;}
<HieroText>"[&"{ESPSO}	{TLINE(); return  DSTRAJOUTAUTEUR;}
<HieroText>{SEPSO}"&]"{ESPSO}	{TLINE(); return  FSTRAJOUTAUTEUR;}
<HieroText>"<"{ESPSO}	{TLINE(); seshlval.un_typegroupe= S_carto; return DEBUTCONSTRUCTION;}
<HieroText>"<"h?[1-3]{ESPSO}	{TLINE(); seshlval.un_typegroupe= S_carto; return DEBUTCONSTRUCTION;}
<HieroText>"<b"{ESPSO}	{TLINE(); seshlval.un_typegroupe= S_debcarto; return DEBUTCONSTRUCTION;}
<HieroText>"<m"{ESPSO}	{TLINE(); seshlval.un_typegroupe= S_milcarto; return DEBUTCONSTRUCTION;}
<HieroText>"<e"{ESPSO}	{TLINE(); seshlval.un_typegroupe= S_fincarto; return DEBUTCONSTRUCTION;}
<HieroText>{SEPSO}">"{ESPSO}	{TLINE(); return CARTF;}
<HieroText>{SEPSO}[HhsSfF]?[1-3]">"{ESPSO}	{TLINE(); return CARTF;}
<HieroText>"<S"{ESPSO}	{TLINE(); seshlval.un_typegroupe= S_serekh; return DEBUTCONSTRUCTION;}
<HieroText>"<S"[1-3]{ESPSO}	{TLINE(); seshlval.un_typegroupe= S_serekh; return DEBUTCONSTRUCTION;}
<HieroText>"<F"{ESPSO}	{TLINE(); seshlval.un_typegroupe= S_enceinte; return DEBUTCONSTRUCTION;}
<HieroText>"<H"{ESPSO}	{TLINE(); seshlval.un_typegroupe= S_chateau; return DEBUTCONSTRUCTION;}
<HieroText>"<H"[1-3]{ESPSO}	{TLINE(); seshlval.un_typegroupe= S_chateau; return DEBUTCONSTRUCTION;}
<HieroText>"<Sb"{ESPSO}	{TLINE(); seshlval.un_typegroupe= S_debserekh; return DEBUTCONSTRUCTION;}
<HieroText>"<Sm"{ESPSO}	{TLINE(); seshlval.un_typegroupe= S_milserekh; return DEBUTCONSTRUCTION;}
<HieroText>"<Se"{ESPSO}	{TLINE(); seshlval.un_typegroupe= S_finserekh; return DEBUTCONSTRUCTION;}
<HieroText>"<Fb"{ESPSO}	{TLINE(); seshlval.un_typegroupe= S_debenceinte; return DEBUTCONSTRUCTION;}
<HieroText>"<Fm"{ESPSO}	{TLINE(); seshlval.un_typegroupe= S_milenceinte; return DEBUTCONSTRUCTION;}
<HieroText>"<Fe"{ESPSO}	{TLINE(); seshlval.un_typegroupe= S_finenceinte; return DEBUTCONSTRUCTION;}
<HieroText>"<Hb"{ESPSO}	{TLINE(); seshlval.un_typegroupe= S_debchateau; return DEBUTCONSTRUCTION;}
<HieroText>"<Hm"{ESPSO}	{TLINE(); seshlval.un_typegroupe= S_milchateau; return DEBUTCONSTRUCTION;}
<HieroText>"<He"{ESPSO}	{TLINE(); seshlval.un_typegroupe= S_finchateau; return DEBUTCONSTRUCTION;}
<HieroText>"#"	{return OVERWRITE;}
<HieroText>"# "	{seshlval.des_hachures= TOUTSHADING; return SHADINGS;}
<HieroText>{SEPSO}"#-"{ESPSO}           |
<HieroText>{SEPSO}"-#"{ESPSO}           |
<HieroText>"-#-"	{return DIEZE;}
<HieroText>{SEPSO}"#b"{ESPSO}                  {if (signe_lu) REJECT; dieze=1-dieze; return DIEZE;}
<HieroText>{SEPSO}"#b"{ESPSO}                  {dieze=1-dieze; return DIEZE;}
<HieroText>{SEPSO}"#e"{ESPSO}                  {dieze=1-dieze; return DIEZE;}
<HieroText>"#"?"#"[1-4]+{ESPSO}	{calcule_hachures(&(seshlval.des_hachures));
	 return SHADINGS;}

<HieroText>{SEPSO}"$"{ESPSO}	{couleur=1-couleur; /* ne compliquons pas la grammaire */
	  if (couleur==1) return RED;
	  else return BLACK;}
<HieroText>{SEPSO}"$b"{ESPSO}                   {couleur=1; return BLACK;}
<HieroText>{SEPSO}"$r"{ESPSO}                   {couleur=0; return RED;}
<HieroText>\\	{return REVERT;}
<HieroText>\\s[0-9]	{
                                          int s=  atoi(yytext+2); 
                                          s= 100 / (1+s);
                                          seshlval.un_entier= s;
                                          return SIZE;  
                                        }
<HieroText>\\{INTEGER}	{
                                          seshlval.un_entier= atoi(yytext+1); 
                                          return SIZE;  
                                        }
<HieroText>\\R{INTEGER}	{
                                          seshlval.un_entier= atoi(yytext+2); 
                                          return ROTATION;  
                                        }
<HieroText>\\r[1-4]	{
                                          seshlval.un_entier= atoi(yytext+2) * 90; 
                                          return ROTATION;  
                                        }
<HieroText>\\t[1-4]	{
                                          seshlval.un_entier= atoi(yytext+2) * 90; 
                                          return NROTATION;  
                                        }
<HieroText>"++"                         BEGIN(COMMENTAIRE);
<HieroText>{SEPSO}"+s"{ESPSO}
<HieroText>"("{ESPSO}	return '(';
<HieroText>")"{ESPSO}	return ')';
<HieroText>(.)	return yytext[0];


<COMMENTAIRE>{ROMTXT}*	BEGIN(HieroText);
<LIGNECOM><<EOF>>	yyterminate();
<LIGNECOM>(.|\n)	{yymore(); }
<LIGNECOM>"+s"{ESPSO}	{TLINE();
	seshlval.une_chaine= 
                                           enleve_plus_a_la_fin(dupliquechaine(yytext));
	return LIGNE_COMMENTAIRE;
	}
\015                                    ;
<HieroText>{ident}	|
<HieroText>([A-Z]|Aa){entier}A*	{
                                          seshlval.une_donnee.texte= dupliquechaine(yytext);
	  signe_lu= TRUE; return HIEROGLYPHE;
	}

<HieroText>"{"[lL]{entier}","{entier}"}"
<HieroText>"{{"{entier}","{entier}","{entier}"}}"
<HieroText>"/h"
<HieroText>"/s"
<HieroText>"/v"
%%

/* 
 * Local Variables:
 * mode: c
 * tab-width: 40
 * header: "seshaux.h"
 * End:
 */
