# Object-oriented command class for stoop
# Inspired from WxWindows

class command {
    proc command {this} {}

    proc ~command {this} {}
    
    # CanUndo -- True if command can be undone
    # returns 1 if command has succeded, 0 otherwise    
    virtual proc CanUndo {this} {return 0}
    
    # Do -- execute the command.
    # returns 1 if command has succeded, 0 otherwise
    virtual proc Do {this}
    
    # GetName --
    # returns name of command
    virtual proc GetName {this}

    # Undo -- undo command if possible
    # Returns 1 if undoing was successful, 0 if not.
    virtual proc Undo {this} {
	return 0
    }
}

class CommandProcessor {
    proc CommandProcessor {this {max 100}} {
    }

    proc ~CommandProcessor {this} {
    }

    virtual proc CanUndo {this} {}

    proc ClearCommands {this} {}

    # Do -- Executes (redoes) the current command (the command that has just been undone if any).

    proc Do {this} {} 
    
    # GetCommands --
    # Returns the list of commands
    
    proc GetCommands {this} {}
    
    # GetMaxCommands --
    # Returns the maximum number of commmands in history
    proc GetMaxCommands {this}
    
    # GetEditMenu --
    proc GetEditMenu {this}
    
    # Initializes --
    # Initializes the command processor, 
    # setting the current command to the last in the list (if any),
    # and updating the edit menu (if one has been specified).

    proc Initialize {this} 
    
    proc SetEditMenu {this menu}
    
    # Submit --
    # Submits a new command
    # if tohistory is true, adds it to command history 
    proc Submit {this command {tohistory 1}} {
    }
    
    proc Undo
    
}
