
class FontEditor {
    global env
    variable ICONDIR [file join $env(SESHLIB) icons]
    proc FontEditor {this parentPath args} composite {
	[new frame $parentPath] $args
    } {
	composite::manage $this\
	    [new frame $widget::($this,path)] menu \
	    [new FontEdit $widget::($this,path)] edi \
	[new labelledFrame $widget::($this,path)] labelf
	    
	set labelpath $composite::($this,labelf,path)

	grid $composite::($this,menu,path) - -sticky ew
	addmenus $this

	grid $composite::($this,edi,path) $labelpath -sticky nsew
	grid rowconfigure $widget::($this,path) 0 -weight 0
	grid rowconfigure $widget::($this,path) 1 -weight 1
	grid rowconfigure $widget::($this,path) 2 -weight 0
	
	FontEdit::setscale $composite::($this,edi) 10 20 300
	#FontEdit::setgrid $composite::($this,edi) 2 2

	FontEdit::repere $composite::($this,edi)


	# Mode choice

	set f0 [new frame $labelpath]
	set fpath0 $widget::($f0,path) 
	
	set edi $composite::($this,edi)
	
	set var FontEdit::($edi,type)

	set pal1 [new radiobutton $fpath0 -variable $var -value "P" -text "black"]
	set pal2 [new radiobutton $fpath0 -variable $var -value "N" -text "white"]
	#set pal3 [new radiobutton $fpath0 -variable $var -value "T" -text "stroke"]
	#set pal4 [new radiobutton $fpath0 -variable $var -value "S" -text "closed"]
	
	grid $widget::($pal1,path) $widget::($pal2,path)
	
	set f1 [new frame $labelpath]
	set fpath1 $widget::($f1,path) 

	set var FontEdit::($edi,state)
	
	set b1 [new radiobutton $fpath1 -variable $var -value add -text "add Contour"]
	set b2 [new radiobutton $fpath1 -variable $var -value delete -text "delete"]
	set b3 [new radiobutton $fpath1 -variable $var -value edit -text "edit Contour"]
	set b4 [new radiobutton $fpath1 -variable $var -value addguide -text "add guide"]
	set b5 [new radiobutton $fpath1 -variable $var -value double -text "double"]
	set b6 [new radiobutton $fpath1 -variable $var -value splinetoline -text "spline <-> line"]
	set b7 [new radiobutton $fpath1 -variable $var -value center -text "center"]
	set b8 [new radiobutton $fpath1 -variable $var -value select -text "select"]
	# set b9 [new radiobutton $fpath1 -variable $var -value move -text "move selection"]
	set b10 [new radiobutton $fpath1 -variable $var -value scale -text "scale selection"]
	set b11 [new radiobutton $fpath1 -variable $var -value lower -text "Lower"]
	

	foreach b [list $b1 $b2 $b3 $b4 $b5 $b6 $b7 $b8 $b10 $b11] {
	    grid $widget::($b,path)
	}
	

	set f2 [new frame $labelpath]
	set fpath2 $widget::($f2,path) 
	
	set bt0 [new button $fpath2 -text "preview" -command [list FontEditor::preview $this]]
	set bt1 [new button $fpath2 -text "clear" -command [list FontEdit::clear $edi] ]
	set bt2 [new scale $fpath2  -from -10  -to 10 \
		     -tickinterval 5.0 -resolution 0.1\
		     -command [list FontEdit::scaleall $edi]]
	set bt3 [new button $fpath2 -text "set char" -command [list FontEdit::savechar $edi]]

	set bt4 [new button $fpath2 -text "get char" -command [list FontEdit::getchar $edi]]
	set bt5 [new button $fpath2 -text "prev" -command [list FontEdit::prevchar $edi]]
	set bt6 [new button $fpath2 -text "next" -command [list FontEdit::nextchar $edi]]		 
	set bt7 [new button $fpath2 -text "hor. invert" -command [list FontEdit::invertlr $edi]]
	set bt8 [new button $fpath2 -text "vert. invert" -command [list FontEdit::invertud $edi]]
	set bt10 [new button $fpath2 -text "Toggle grid" -command [list FontEdit::toggleGrid $edi]]
	set bt9 [new entry $fpath2 -textvariable FontEdit::($edi,char)]
	
	bind  $widget::($bt9,path) <Return> [list FontEdit::getchar $edi]

	grid $widget::($bt2,path)
	grid   $widget::($bt1,path) $widget::($bt0,path) 
	grid   $widget::($bt3,path) $widget::($bt4,path) 
	grid   $widget::($bt5,path) $widget::($bt6,path) 
	grid   $widget::($bt7,path) $widget::($bt8,path)
	grid   $widget::($bt7,path) $widget::($bt8,path)
	grid   $widget::($bt9,path) -
	grid   $widget::($bt10,path) x
	
	
	#set fpath3 [Sesh  $widget::($this,path).thesesh -height 100 -htline 100 -draw_cursor 0]
	set sesh [new Sesh $labelpath -height 100 -htline 100 -draw_cursor 0]
	set fpath3 $widget::($sesh,path)
	set ($this,preview) $sesh
 
	grid $fpath0 -
	grid $fpath1 $fpath2
	grid $fpath3 -
	composite::complete $this
	#after 100 FontEditor::updatepreview $this
    }

    proc updatepreview {this} {
	catch {preview $this}
	#after 10000 FontEditor::updatepreview $this
    }
    
    proc preview {this} {
	set s $widget::($FontEditor::($this,preview),path)
	set t [FontEdit::asText $composite::($this,edi)]
	$s delete 0.0 end
	tksesh_defchar tmp $t
	$s insert insert tmp
    }
    
    proc showasText {this} {
	puts [FontEdit::asText $composite::($this,edi)]
    }

    proc addmenus {this} {
	set menus $composite::($this,menu,path)
	menubutton $menus.file -text "File" -menu $menus.file.m	
	menubutton $menus.edit -text "Edit" -menu $menus.edit.m
	pack $menus.file $menus.edit -side left

	menu $menus.file.m
	menu $menus.edit.m

	$menus.file.m add command -label "load" \
	    -command [list FontEditor::loadfont $this]

	$menus.file.m add command -label "save" \
	    -command [list FontEditor::savefont $this]

	$menus.file.m add command -label "load image" \
	    -command [list FontEditor::loadimage $this]

	$menus.file.m add command -label "delete image" \
	    -command [list FontEditor::delete_image $this]

	$menus.file.m add command -label "export sign" \
	    -command [list FontEditor::SignExporter $this]

	$menus.file.m add command -label "Quit" \
	    -command {destroy .}

	$menus.edit.m add command -label "cut" \
	    -accelerator "CTRL-x"\
	    -command [list FontEditor::cut $this]

	$menus.edit.m add command -label "copy" \
	    -accelerator "CTRL-c"\
	    -command [list FontEditor::copy $this]

	$menus.edit.m add command -label "paste" \
	    -accelerator "CTRL-v"\
	    -command [list FontEditor::paste $this]

    }

    proc ~FontEditor {this} {}

    proc cut {this} {
	copy $this
	FontEdit::clear $composite::($this,edi)
    }

    proc copy {this} {
	clipboard clear 
	clipboard append [FontEdit::asText $composite::($this,edi)]
    }

    proc paste {this} {
	set txt [selection get -selection CLIPBOARD]
	FontEdit::addtext $composite::($this,edi) [lrange $txt 6 end]
    }

    proc loadfont {this} {
	set patterns {{{BZR file} {.bzr}} {Any *}}
	set name [tk_getOpenFile \
		      -defaultextension .bzr -filetypes $patterns]
	FontEdit::load $composite::($this,edi) $name
    }

    proc loadimage {this} {
	set patterns {{{gif file} {.gif}} {Any *}}
	set name [tk_getOpenFile \
		      -defaultextension .gif -filetypes $patterns]
	FontEdit::loadimg $composite::($this,edi) $name
    }

    proc delete_image {this} {
	FontEdit::delimg $composite::($this,edi)
    }

    proc savefont {this} {
	set patterns {{{BZR file} {.bzr}} {Any *}}
	set name [tk_getSaveFile \
		      -defaultextension .bzr -filetypes $patterns]
	FontEdit::save $composite::($this,edi) $name
    }

    proc options {this} {}

    proc SignExporter {this} {
	set ($this,export_window) [toplevel .SignExporter]
	set f [new SignExporter $this .SignExporter]
	set ($this,export_subwindow) $f
	pack $widget::($f,path)
    }

    proc delete_export {this} {
	delete  $FontEditor::($this,export_subwindow)
	#delete $FontEditor::($this,export_window)
	destroy $FontEditor::($this,export_window)
    }
    
    proc export {this name} {
	set txt [FontEdit::asText $composite::($this,edi)]
	clipboard clear 
	clipboard append [list SGN $name $txt]
	delete_export $this
    }

    proc cancel_export {this} {
	delete_export $this
    }
}

