class Selection {
    
    proc Selection {this window} {
	set Selection::($this,cont) {}
	set Selection::($this,window) $window
    }
    
    proc ~Selection {this} {
    }

    proc add {this cont} {
	set w $widget::($Selection::($this,window),path)
	$w addtag selected withtag [GraphElt::allTagName $cont]
	lappend Selection::($this,cont) $cont
	update_selbox $this
    }

    proc asText {this} {
	set res [list]
	foreach c $($this,cont) {
	    lappend res [Contour::asText $c]
	}
	return $res
    }
    
    proc suppress {this cont} {
	set w $widget::($Selection::($this,window),path)
	$w dtag [GraphElt::allTagName $cont] selected
	listreplace Selection::($this,cont) $cont
	update_selbox $this
    }

    proc update_selbox {this} {
	set l [llength $Selection::($this,cont)]
	delete_selbox $this
	if  {$l != 0} {
	    catch {create_selbox $this}
	}
    }

    proc create_selbox {this} {
	set w $widget::($Selection::($this,window),path)
	foreach {llx ury urx lly} [$w bbox selected] {}
	# create a button at pos. urx and ury.
	# THERE SHOULD BE A CLASS FOR THIS.
	# I should in fact change ContourControlPoint and cut it into two levels.
	set b [$w create oval [expr $urx - 2] [expr $ury - 2]\
		   [expr $urx + 2] [expr $ury + 2] -fill darkgreen]
	$w bind $b <B1-Motion> [list Selection::scale $this %x %y]
	$w addtag selected withtag $b
	set ($this,button) $b
    }

    proc delete_selbox {this} {
 	set w $widget::($Selection::($this,window),path)
	catch {$w delete $Selection::($this,button)}
    }

    proc scale {this x y} {
	set w $widget::($Selection::($this,window),path)
	foreach {llx ury urx lly} [$w bbox selected] {}
	# scaling center :
	set sx [expr "($urx + $llx)/2.0"]
	set sy [expr "($ury + $lly)/2.0"]
	# scaling factor :
	set sf [expr "1.0*($x - $sx) / ($urx - $sx)"]
	$w scale selected $sx $sy $sf $sf
    }

    
    proc clear {this} {
	foreach i $Selection::($this,cont) {
	    Contour::unselect $this
	}
    }
}
