package require dbbrowse

###############################################################################
#			      les menus hiroglyphiques
#set bitmapsd $env(SESHLIB)/Bitmaps
source [file join  $env(SESHLIB) signearray.tcl]

#package require Pbmtoxbm

set namefontes [list \
		    [legendes::trans "Man and his occupations"]\
		    [legendes::trans "Woman and her occupations"]\
		    [legendes::trans "Anthropomorphic Deities"]\
		    [legendes::trans "Parts of the human body"]\
		    [legendes::trans "Mammals"]\
		    [legendes::trans "Parts of Mammals"]\
		    [legendes::trans "Birds"]\
		    [legendes::trans "Parts of Birds"]\
		    [legendes::trans "Amphibious animals, reptiles, etc."]\
		    [legendes::trans "Fishes and parts of fishes"]\
		    [legendes::trans "Invertebrata and lesser animals"]\
		    [legendes::trans "Trees and plants"]\
		    [legendes::trans "Sky, earth, water"]\
		    [legendes::trans "Buildings, parts of buildings, etc."]\
		    [legendes::trans "Ships and parts of ships"]\
		    [legendes::trans "Domestic and funerary furniture"]\
		    [legendes::trans "Temple furniture and sacred emblems"]\
		    [legendes::trans "Crowns, Dress, Staves, etc."]\
		    [legendes::trans "Warfare, hunting, butchery"]\
		    [legendes::trans "Agriculture, crafts, and professions"]\
		    [legendes::trans "Rope, Fibre, baskets, bags, etc."]\
		    [legendes::trans "Vessels of stone and earthenware"]\
		    [legendes::trans "Loaves and cakes"]\
		    [legendes::trans "Writings, games, music"]\
		    [legendes::trans "Strokes"]\
		    [legendes::trans "Unclassified"]\
		   ]

# proc charger_bitmaps {signe} {
#     global bitmapsd signesN signesF lesbitmapes
#     set pbmf "$bitmapsd/[signes::fontbitmapfile $signe]"
#     set lesbitmapes([signes::nom_bitmap $signe]) \
# 	    [image create bitmap -data [pbm2xbm $pbmf]]
# }

# proc alt_bitmap {win signe} {
#     global bitmapsd signesN signesF lesbitmapes
#     seshw::set_text $win $signe
#     seshw::autosize $win
#     set lesbitmapes([signes::nom_bitmap $signe]) \
# 	    [image create bitmap -data  [$win undocumented4 -xbm]]
# }

# proc alt_bitmap1 {win signe} {
#     global bitmapsd signesN signesF lesbitmapes
#     seshw::set_text $win $signe
#     seshw::autosize $win
#     set lesbitmapes([signes::nom_bitmap $signe]) \
# 	    [image create bitmap -data  [$win undocumented4 -xbm]]
# }

proc bitmapsign {signe} {
    global lesbitmapes
    return $lesbitmapes([signes::nom_bitmap $signe])
}

proc quit_menu_glyph {fen keep} {
    grab release $fen
    if {$keep == 1} {
	wm withdraw $fen
    } else {
	destroy $fen
    }                
    focus -force .w.s
}

proc glyphmenucommand {sign fen keep} {
    seshw::insertSignByCode .w.s $sign
    quit_menu_glyph $fen $keep
}

proc glyphinfo {sign fen} {
    $fen.info.signe	configure -text $sign
    set val [signes::values_for_sign $sign]
    $fen.info.val configure -text $val
}

proc fairemenu {nommenu signes keep} {
    #global bitmapsd
    set fen .menusignes$nommenu
    eval [list toplevel $fen]
    eval [wm transient $fen .] 
    
    button $fen.quit -text Cancel \
	    -command [list quit_menu_glyph $fen $keep]
    pack $fen.quit -side left
    set k 1
    foreach i $signes {
	if [expr $k % 8 == 1] then {
	    set maframe $fen.frm$k
	    frame $maframe
	} 
	eval [list button $maframe.w$k -image [bitmapsign $i] \
		-command [list glyphmenucommand $i $fen $keep]]
        bind $maframe.w$k <FocusIn> [list glyphinfo $i $fen]
        bind $maframe.w$k <Enter> [list glyphinfo $i $fen]

	set topack [append topack "$maframe.w$k "]
	if [expr $k % 8 == 0] then {
	    pack $maframe
	    eval pack $topack -side left
	    set topack ""
	}
	set k [expr $k + 1]
    }
    catch {				# $topack could be empty
    pack $maframe
    eval pack $topack -side left
    }
    frame $fen.info
    pack $fen.info
    label $fen.info.l1 -text sign
    label $fen.info.signe 
    label $fen.info.l2 -text val
    label $fen.info.val
    pack $fen.info.l1 $fen.info.signe $fen.info.l2 $fen.info.val -side left
    return $fen
}

proc fairemenultr {lettre grab} {
    if [winfo exists .menusignes$lettre] {
	wm deiconify .menusignes$lettre
	raise .menusignes$lettre
    } else {
	fairemenu $lettre [signes::signes_in_lettre $lettre] 1 
    }
    if {$grab} {
    focus .menusignes$lettre
    grab set .menusignes$lettre
    }
}

###############################################################################
#                             Glossary

proc gname {} {
    return [file join [seshuser::getvar PATH] glossary.glo]
}

proc load_glossary {} {
    global env
    set g1 [file join $env(SESHLIB) glossary.glo]
    set g2 [gname]
    
    seshw::load_glossaries $g1 $g2
}

proc save_glossary {} {
    set g2 [gname]
    seshw::save_glossary $g2
}

proc ouvrir_glossaire {} {
    if 1 {
	toplevel .gloss
	listbox .gloss.liste -yscroll ".gloss.scroll set" -width 20 -height 20
	scrollbar .gloss.scroll -command ".gloss.liste yview"
	pack .gloss.liste .gloss.scroll -side left -fill both
	seshw::create_editor .gloss.hie -notitle
	label .gloss.lab -textvariable glossvar
	entry .gloss.entry
	pack .gloss.hie .gloss.lab .gloss.entry
	button .gloss.set -text [legendes::trans "Set"] \
		-command {
	    seshw::set_glossary [.gloss.entry get] \
		    [[seshw::gethwindow .gloss.hie] get 0.0 end]
	    .gloss.liste insert end [.gloss.entry get]
	}
	button .gloss.save -text [legendes::trans "Save"] \
		-command save_glossary
	pack .gloss.set .gloss.save
	foreach t [seshw::list_glossary_entries] {
	    .gloss.liste insert end $t
	}
#  	bind .gloss.entry <Return> {
#  	    seshw::set_glossary [.gloss.entry get] \
#  		    [selection get -selection $env(DEFAULTSELECTION)]
#  	    .gloss.liste insert end [.gloss.entry get]
#  	}
    }
}

###############################################################################
#			      Copie des rfrences

proc SESH_insert_ref {} {
    clipboard clear 
    clipboard append [seshw::getref .w]
}

###############################################################################
#			      Recherche de mot

package require seshsearch

proc ouvrir_recherche {} {
    toplevel .reche
    seshsearch::create .reche.g
    grid .reche.g -sticky news
    grid rowconfigure .reche 0 -weight 1
    grid columnconfigure .reche 0 -weight 1
}

package require tradedit

proc ouvrir_traduction {} {
    set w .trad
    toplevel $w -menu .trad.mb
    wm title $w [legendes::trans "Translation editor (Beware, just a model !)"]
    tradedit::createmenu $w.mb .trad
    tradedit::create $w
}

###############################################################################
#			      File loading and saving

set nom_du_fichier ""

proc new_text {w} {
    seshw::clear_text $w.s
    seshw::set_scribe $w [seshuser::getvar NAME]
    seshw::set_scribe_code $w [seshuser::getvar ID]
}

proc executer_commande_fichier {commande nom} {
    global nom_du_fichier
    if {$nom == "" } return
    eval [list $commande $nom]
    set nom_du_fichier $nom
}

proc nom_fichier {quoi commande} {
    global nom_du_fichier
    set patterns {{{MDC file} {.gly .hie}} {Any *}}
    switch $quoi {
	{Load} {
	    set nom [tk_getOpenFile \
		    -defaultextension .hie -filetypes $patterns]
	}
	{Save} {
	    set repertoire [file dirname $nom_du_fichier]
	    set fic [file tail $nom_du_fichier]
	    
	    # Now something strange. tk_getSaveFile -initialfile doesn't work properly
	    # after tk_getOpenFile !

	    if {$nom_du_fichier != "" } {
		     set nom [tk_getSaveFile \
			-initialfile $fic\
			-initialdir $repertoire\
			-defaultextension .hie -filetypes $patterns]
	    } else {
		set nom [tk_getSaveFile \
			-defaultextension .hie -filetypes $patterns]
	    }
	    if {$nom != "" && [file extension $nom] == ""} {
		append nom ".hie"
	    }
	}
    }
    if {$nom != ""} {executer_commande_fichier $commande $nom}
}


proc charger_fichier {fic} {
    set f [open $fic]
    set txt [read $f]
    close $f
    seshw::fromtext .w $txt
}

proc sauver_fichier {fic} {
    set txt [seshw::totext .w]
    set f [open $fic w]
    set txt [puts $f $txt]
    close $f
}

# package require dbfilesel
#
# Temporary solution.
proc chosetext {} {
    ### JUST AS TEST :
    puts [seshtext::directory]
    puts end
    ##
    
    set w .textchoser
    toplevel $w
    dbbrowse::create $w.l \
	-head hie \
	-idx texts
    dbbrowse::setload $w.l chosedtextloader
    dbbrowse::setfirst $w.l 0
    button $w.close -text [legendes::trans "Cancel"] \
	    -command [list destroy $w]
    grid $w.l -sticky news
    grid $w.close -sticky ew 
    grid rowconfigure $w 0 -weight 1
    grid columnconfigure $w 0 -weight 1
    bind $w.l.list <Delete> [list deleteMyText $w]
#     catch {
# 	set name [dbfilesel::getname -ext hie]
# 	seshw::gettext .w $name
#     }
}

# Delete Marked text. Should move to dbbrowse
# (as an option)
proc deleteMyText {w} {
    set txt [lindex [dbbrowse::getidx $w.l] 1]
    seshtext::delete $txt
}

proc chosedtextloader {w} {
    set v [dbbrowse::getidx $w]
    set v [tag::value $v]
    puts $v
    seshw::gettext .w $v
    destroy .textchoser
}

#####################################################################
# saving the user's dictionary to a file :

proc save_dico {} {
    set patterns {{{dictionary file} {.dic}} {Any *}}
    set name [tk_getSaveFile -defaultextension .dic -filetypes $patterns]
    if {[string compare $name ""] != 0} {
	set txt [seshbase::user_dump dico]
	set f [open $name w]
	puts $f $txt
	close $f
    }
}

#######################################################################


proc open_note {} {
    toplevel .note
    dbbrowse::create .note.l -head TITLE
    dbbrowse::setload .note.l putnote
    dbbrowse::setfirst .note.l 1
    dico::create .note.d NOTE
    grid .note.l -sticky news
    grid .note.d -sticky news
    grid rowconfigure .note 1 -weight 1
    grid columnconfigure .note 0 -weight 1
}

proc putnote {w} {
    set v [lindex [dbbrowse::getval $w] 0]
    dico::load .note.d $v
}
