
package require seshw
package require signesdef
package require seshuser

if {! [seshuser::loaduser] } {
    wm withdraw . 
    seshuser::dialogue
    wm deiconify .
}

namespace eval ligedit {
    variable VARS
    
    proc create {f} {
	global env

	frame $f

	frame $f.f1
	seshw::create_passive $f.s -width 80

	label $f.f1.l1 -text "nom"	
	entry $f.f1.lig
	grid $f.f1.l1 $f.f1.lig

	frame $f.f2
	
	foreach i {1 2 3 4} {
	    set fi$i [image create bitmap\
			  -file [file join $env(SESHLIB) icons f$i.xbm]]
	}
	
	button $f.f2.b1 -image $fi1 -command [list ligedit::up $f]
	button $f.f2.b2 -image $fi2 -command [list ligedit::right $f]
	button $f.f2.b3 -image $fi3 -command [list ligedit::down $f]
	button $f.f2.b4 -image $fi4 -command [list ligedit::left $f]

	grid x $f.f2.b1 x
	grid $f.f2.b4 x $f.f2.b2
	grid x $f.f2.b3 x

	frame $f.f3
	button $f.f3.plus -text "+" -command [list ligedit::changesize $f 1]
	button $f.f3.moins -text "-" -command [list ligedit::changesize $f -1]
	grid $f.f3.plus
	grid $f.f3.moins

	frame $f.f4
	button $f.f4.prev -text "<" -command [list ligedit::next $f]
	button $f.f4.next -text ">" -command [list ligedit::previous $f]
	label $f.f4.sign -width 4 -relief  sunken
	grid $f.f4.prev $f.f4.sign $f.f4.next 
	
	button $f.save -text "save" -command [list signesdef::ssave]
	grid $f.s  $f.f1 -
	grid ^   $f.f2 $f.f3
	grid $f.save    $f.f4 -

	bind $f.f1.lig <Return> [list ligedit::newlig $f]
	bind $f.s <Button-1> [list ligedit::click $f %x %y]
	return $f
    } 


    proc click {w x y} {
	puts "click at $x $y"
    }

    proc newlig {w} {
	clear $w
	set t [$w.f1.lig get]
	setlig $w $t
	show_lig $w
    }

    proc clear {w} {
	variable VARS
	seshw::set_text $w.s ""
	foreach i [array names VARS $w,sign,*] {
	    unset VARS($i)
	}
	#$w.f1.lig configure -text {}
	$w.f4.sign configure -text {}
    }

    proc setlig {w txt} {
	variable VARS
	set l [split $txt &]
	set VARS($w,lig) $txt
	set VARS($w,size) [llength $l]
	set i 0
	foreach s $l {
	    set VARS($w,sign,$i,code) $s
	    set VARS($w,sign,$i,size) 100
	    set VARS($w,sign,$i,x) 0
	    set VARS($w,sign,$i,y) 0
	    incr i
	}
	setsign $w 0
    }

    proc buildcom {w} {
	variable VARS
	set n $VARS($w,size)
	set com [list $n]
	for {set i 0} {$i < $n} {incr i} {
	    lappend com $VARS($w,sign,$i,code)
	    lappend com $VARS($w,sign,$i,x)
	    lappend com $VARS($w,sign,$i,y)
	    lappend com $VARS($w,sign,$i,size)
	}
	return [list signesdef::deflig $VARS($w,lig) $com 1]
    }

    proc setsign {w i} {
	variable VARS
	set VARS($w,curr) $i
	show_curr_sign $w
    }

    proc next {w} {
	variable VARS
	set VARS($w,curr) \
	    [expr ( $VARS($w,curr) + 1 ) % $VARS($w,size)]
	show_curr_sign $w
    }

    proc previous {w} {
	variable VARS
	set VARS($w,curr) \
	    [expr ( $VARS($w,curr) + 1 ) % $VARS($w,size)]
	show_curr_sign $w
    }

    proc delta {w x y} {
	variable VARS
	set i $VARS($w,curr)
	incr VARS($w,sign,$i,x) $x
	incr VARS($w,sign,$i,y) $y
	show_lig $w
    }

    proc up {w} {
	delta $w 0 1
    }

    proc down {w} {
	delta $w 0 -1
    }

    proc left {w} {
	delta $w -1 0
    }

    proc right {w} {
	delta $w 1 0
    }

    proc changesize {w s} {
	variable VARS
	set i $VARS($w,curr)
	incr VARS($w,sign,$i,size) $s
	show_lig $w
    }

    proc show_lig {w} {
	variable VARS
	seshw::set_text $w.s ""
	set c [buildcom $w]
	eval $c
	seshw::set_text $w.s $VARS($w,lig) 
    }

    proc show_curr_sign {w} {
	variable VARS
	set i $VARS($w,curr)
 	$w.f4.sign configure -text $VARS($w,sign,$i,code)
    }
}

ligedit::create .f
ligedit::clear .f

signesdef::sload
pack .f
