
--		TKSESH 
--	Ancient Egyptian Database
--

-- 
--  		Table creation for SQL Lite Database
--  


-- 
--   Sql Lite doesn't define any blob or suchlike structure. As we need them,
--   we simulate them with a table. As entries have a limited size of
--   65535 bytes, we avoid any problem with UTF-8 by using a maximum
--   size of 30000. Of course, it's our responsability to do so, as
--   sqlite is unable to.
--  

CREATE TABLE Blob (
       id int,
       num int, 
       val varchar(30000), 
       PRIMARY KEY (id,num)
);

-- insert into blob values (1,1,"un t  la Goulette");


-- a glyph created by a user.

CREATE TABLE Glyph (
       -- Header : common to all signed data
       -- (inheritance is the key word here)
       -- creator
       uid int,
       -- creator machine number
       mid int,
       -- specific id for this item
       id int,
       -- A sign code is : U<uid>m<mid>s<id>
       -- for instance, the first sign user 5 will create will have code :
       -- U5m0s0
       -- Glyph-specific code
       -- id of the blob which contains the drawing
       code int, -- blob !
       guides int, -- blob : guidelines
       PRIMARY KEY (uid,mid,id)
);

-- 
-- table for "Official" Manuel de codage codes.
--

create table MDCCode (
       code varchar(50),
       uid int,
       mid int,
       id int,
       PRIMARY KEY (code)
);

-- User statements on signs.





