# seshSigns.tcl --
#
#	New package for working with hieroglyphic signs. 
#	This one uses the database system for sign loading
#	This package deals only with database matters.
#


# Scenario for sign creation :
# The sign is NOT given an ID until it is saved in the base
# if a sign has not been published, it is possible to load and 
# modify it.

# First the sign is edited anonymously
# 
# Then, the user saves it :
# set id [Glyph::createSign $uid $drawing]
# ... 
# as long as the sign is not published, it can be changed :
#
# Glyph::setGlyph $uid $id $drawing



package provide seshSigns 0.0

package require seshuser

# Data represented :
#
# Glyph : an actual drawing
# AbstractSign : a sign, which can be represented as glyphs
# GlyphSpecification : relates a glyph to an abstract sign.
# Value : a sign value, either PhoneticValue or NonPhoneticValue
# ValueSpecification : links a AbstractSign and a Value
# SignEquivalence : 


# GlyphCode : codes attributed to a glyph.
# A particular glyph has one or more codes.
# but a code belongs to one and only one glyph.


namespace eval GlyphCode {
}
# glyph --
# 	An actual drawing. 
#	a glyph has a unique id, of the form UuSn
#	where u is the user ID, and n the sign number.
#
#	entry : ID, SHARED, DRAWING, CONSTRUCTION LINES

namespace eval Glyph {
    variable VAR

    proc setGlyph {uid sid drawing} {
    }
    
    proc getDrawing {uid sid} {
    }
    
    proc getCode {uid sid} {
	return "U${uid}G$sid"
    }
}


namespace eval GlyphIterator {} {
    variable VAR

    proc createIterator {} {
    }
    
    proc createUserIterator {uid} {
    }

    proc createIteratorFrom {uid id} {
    }

    proc next {i} {
    }

    proc get {i} {
    }

    proc hasNext {i} {
    }
}

# hasCode --
# 	Links glyphs and Gardiner codes 
#	(mdc phonetic values are limited in number, and hardlinked)
#	the "hasCode" relation is SIGNED. That is, 
#	it is explicitely made by a USER. Other users are free to 
#	keep it or to leave it (well, will be free).

# isSignVariant --
#	links two codes. 
#	state that they are variant codes for the same sign. 

# phoneticValue --
#	state that a given sign has a phonetic value. SIGNED.

