# seshTable.tcl
#
#	Deals with tables in the Sesh database.
#	allows saving, loading, navigating in these tables.

#  2001 Serge Rosmorduc
# rosmord@iut.univ-paris8.fr
# quipe langue et littrature gyptienne, EPHE IVme section
#
# 
# voyez le fichier ../LICENCE.txt pour plus d'informations
# See the ../LICENCEE.txt file for more information
#
# $Id$
#

# $Log$
#

# DATA STRUCTURE SUMMARY :
#
# In the database :
#
# any key has a prefix which indicates its kind :
#
# ADM TABLE <TABLENAME> => <TABLE INFO>
# informations about a table
# (more below)
# 
# ADM MAXIDX <TABLENAME> => for tables with an automatic index.
#
# ENTRY TABLE <IDX> => Entry in a table
# IDX <TABLE> <IDX> => indexed pointers in a table, for secondary indexes.
# 
#
# Signed indexes :
w# 
# "Signed" means here that someone's ID is used to sign an index entry,
# it doesn't mean +/- like in C.
#
# Indexes are either notSigned or signed.
# notSigned indexes should be reserved for internal values which won't be exported.
# anything exported should be signed.
#
# composite signature : a signature contains two things :
# the user ID, and a machine ID. The user can freely chose the machine ID.
# the idea is that someone may install tksesh on more than one machine. the machine
# ID will allow him to have a coherent database. 
# 
# 
# FUNCTION SUMMARY --
# 
#
# 

# getNewID TAG : returns the current maximal value for a tag.

# get TAG ID : get an element's value

# update TAG ID VALUE

# make TAG VALUE (returns the ID for the created element)

# getTAGIterator TAG [FIRSTID] : get an iterator on a particular tag.
# with optionnal FIRSTID, sends an iterator pointing to the first element with this value.
# if no such element is available, the iterator will end immediatly.


# only after the COMMIT 

package require stooop 4                                  ;# load stooop package
namespace import stooop::*                ;# and import class, new, ... commands

# A database representation.

class SeshDB {
    proc SeshDB {this} {
    }

    proc ~SeshDB {this} {
    }

    proc writeData {this key data} {
    }

    proc getData {this key} {
    }

    proc getTableNames {this} {
    }
    
}

# An iterator on the database.

class DBIterator {
    
    proc DBIterator {this db first} {
	
    }

    proc ~DBIterator {this} {
    }

    proc next {this} {
    }

    proc hasVal {this} {
    }

    proc getVal {this} {
    }
}

class SeshTable {
    
    # Open table in database
    proc SeshTable {this database name} {
	set ($this,db) $database
	set ($this,name) $name
    }

    proc ~SeshTable {} {}

    proc create {this fields indexes} {
	
    }
    
    proc open {this} {
    }

    proc close {this} {
    }

    proc insert {this val} {
    }

    proc remove {this oid} {
    }

    proc getVals {this oid} {
    }

    proc getVal {this oid} {
    }

    proc getSimpleCursor {this cond} {
	return [new SimpleCursor $this $cond]
    }

    proc getPlainCursor {this} {
	return [new PlainCursor $this]
    }
}

# Basically, a cursor is an iterator.

class Cursor {
    
    proc Cursor {this tbl} {
	set ($this,table) $tbl
    }
    
    proc ~Cursor {this} {}

    virtual proc hasVal {this}

    # gets the cursor's current value.
    virtual proc getVal {this}

    # Advances to next item
    virtual proc next {this}

    # Advances to previous item :
    virtual proc prev {this}
    
    proc getTable {this} {return $($this,table)}
}

class SimpleCursor {

    # Private constructor
    # @param tbl : the table
    # @param cond : the condition put on the cursor.
    # 		    syntax : attr op val.
    #	            where op is one of -eq, -ge, -le, -lt, -gt
    
    proc SimpleCursor {this tbl cond} Cursor {$tbl} {
	
    }

    proc ~SimpleCursor {this} {
    }
}

class PlainCursor {
    
    proc PlainCursor {this tbl} Cursor {$tbl} {
	
    }

    proc ~PlainCursor {this} {
    }
}

# A filtering class :
# only 
class FilterCursor {
    
}

