# signesdef.tcl --
#
#       Adding new signs and new ligatures
# 
#

package provide signesdef 0.0
package require signes
package require Tksesh
package require seshuser

namespace eval signesdef {
    namespace export loadsigns
    namespace export setfont
    namespace export set_charcode
    namespace export is_code
    namespace export sload
    variable fontcodes
    
    variable userlig
    variable userchars
    variable userfonts
    
    array set userfonts {}
    array set userlig {}
    array set userchars {}
    
    proc sload {} {
	set f [file join [seshuser::getvar PATH] defs.tcl]
	if [file exists $f] {
	    source $f
	}
    }

    proc ssave {} {
	variable userlig
	variable userchars
	variable userfonts
	set fname [file join [seshuser::getvar PATH] defs.tcl]
	set f [open $fname w]
	foreach l [array names userfonts] {
	    puts $f "signesdef::setfont $l 1"
	}
	foreach l [array names userchars] {
	    puts $f $userchars($l)
	}
	foreach l [array names userlig] {
	    puts $f "signesdef::deflig $l {$userlig($l)} 1"
	}
	close $f
    }

    ################################################################
    # Routine for global font loading. 
    #
    #

    proc setfont {name {user 0}} {
	variable fontcodes
	variable userfonts
	global env
	if {$user} {
	    set file [file join [seshuser::getvar PATH] $name.bzr]
	} else {
	    set file [file join $env(SESHLIB) goodbzr $name.bzr]
	}
	set fontcodes($name) [tksesh_font $file]
	if $user {
	    set userfonts($name) 1
	}
    }

    proc set_charcode {code font num {user 0}} {
	variable fontcodes
	variable userchars
	if [catch {tksesh_setchar $code $fontcodes($font) $num} err] {
	    puts "problem with $code $font $num"
	} else {
	    signes::register_sign $code
	    if {$user} {
		set userchars($code) "signesdef::set_charcode $code $font $num 1"
	    }
	}
    }

    proc deflig {code command {user 0}} {
	variable userlig
	eval tksesh_setlig $command
	if $user {
	    set  userlig($code) $command
	}
    }

}
