# myopts.tcl --
#
#
# Copyright (c) 2000 Serge Rosmorduc
#

#
# 
#  1998,2000 Serge Rosmorduc,
# quipe EC.art, Laboratoire LRIA, Universit de Paris 8
#
# 15 rue Catulienne
# 93236 St Denis Cedex
# FRANCE
#
# Tout droits rservs.
# 
# voyez le fichier ../LICENCE.txt pour plus d'informations
# See the ../LICENCEE.txt file for more information
#
# $Id$
#
#

#
# $Log$
#
package provide myopts 0.0
package require legendes

namespace eval myopts {
    namespace export myopts

    # myopts::myopts --
    #	manages options. Fills an array with either default
    #	values or values passed as parameters
    #
    # Parameters :
    #	opts	: name of the array which will contain the option values
    #	optlist	: a definition of the options, as a list of flags and default values
    #	arglist	: the argument list (typically gotten from an "args" argument)
    #
    # Options:
    # Results:
    #	None
    # Side Effects:
    #	the opts array is filled.
    # Use:
    #	PUBLIC
    # Called by:
    
    proc myopts {opts optlist arglist} {
	upvar $opts o
	
	foreach {name value} $optlist {
	    set o($name) $value
	}
    
	foreach {name value} $arglist {
	    set code [catch {set tmp $o($name)} err]
	    
	    if { $code != 0} {
		tk_dialog  .dialog  [legendes::trans "error"]\
			[legendes::trans "A function received an unexpected argument: %s. This is a bug, please report" $name] \
			"" 0 [legendes::trans "Ok"]
	    }
	    set o($name) $value
	}
    }
}
