# parall.tcl --
#
#
# Editor for transliteration, translation, and more generally work on
# ancient egyptian texts. The editor allows to edit notes, work on
# parallel texts with possibly multiple translation and
# transliterations.


#
# 
#  2000 Serge Rosmorduc,
# quipe EC.art, Laboratoire LRIA, Universit de Paris 8
#
# 15 rue Catulienne
# 93236 St Denis Cedex
# FRANCE
#
# Tout droits rservs.
# 
# voyez le fichier ../LICENCE.txt pour plus d'informations
# See the ../LICENCEE.txt file for more information
#
# $Id$
#
#

#
# $Log$
#

#
# Internal data representation

package provide parall 0.0

namespace eval parall {
    variable VARS
    # parall::create --
    # 	create a new parallel editor
    # Parameters:
    # Options:
    # Results:
    # Side Effects:
    # Use:
    #	PUBLIC
    # Called by:

    proc create {w} {
	frame $w
    }

    proc delete {w} {
    }

    proc previous {w} {
    }

    proc next {w} {
    }
    
    proc load {w} {
    }

    proc save {w} {
    }

    proc add {w sub} {
    }
}

set comment {
    The parallel text structure is the following :
    
    a WORK is a list of SECTIONS.

    a SECTION correspond to multiple segments in parallel.
    
    So, you can't have things like :
    
    * seg1 seg2 *
    * seg3......*
    
    with seg3 spanning both seg1 and seg2.

    for small variants, notes could be used instead.

    a SECTION can contain :
    
    a) various text fragments : transliterations, translation, etc...
    b) other SECTION(S).

    This way, one can group texts and translations if needed.

    Notes are conceptually separated from the text they concern,
    although it need not be true while editing.


    hieroglyphic text is extracted from the database texts. So the
    work doesn't contain the hieroglyphic text, but only references to
    it.
}

unset comment