/* %%%%% evolutionTD.pl %%%% */

/* TRAITE LES EVOLUTIONS DE T EN t ET DE D EN d */

confusion_de_lettres(T, T, T, T, N, N) :- !.
	
confusion_de_lettres(T1, T2, T1f, T2f, N0, Nf) :- 
	confusion_liee_a_un_T(T1, T2, T1a, T2a, N0, N1), 
	confusion_liee_a_un_D(T1a, T2a, T1f, T2f, N1, Nf).


/* CONFUSION LIEE A UN T */

confusion_liee_a_un_T(T1, T2, T1t, T2t, N1, N2) :-
	(membre('T',T1) ; membre('T',T2)), /*l'un des 2 mots contient un 'T' */
	remplace_T_par_t(T2, T2t),
	remplace_T_par_t(T1, T1t),
	N2 is N1 + 1.

confusion_liee_a_un_T(T1, T2, T1, T2, N, N). 
	

/* CONFUSION LIEE A UN D */

confusion_liee_a_un_D(T1, T2, T1d, T2d, N1, N2) :-
	(membre('D',T1) ; membre('D',T2)),
	remplace_D_par_d(T2, T2d),
	remplace_D_par_d(T1, T1d),
	N2 is  N1 + 1.

confusion_liee_a_un_D(T1, T2, T1, T2, N, N).
	


/* prend en argument le 1er mot, contenant un 'T', et renvoie le meme mot avec tous les 'T' transformes en 't' */

remplace_T_par_t([], []).	
remplace_T_par_t(['T' | X], [t | Xt]) :-
	remplace_T_par_t(X, Xt).
remplace_T_par_t([Y | X], [ Y | Xt]) :- 
	(Y \= 'T'),
	remplace_T_par_t(X, Xt).

/* prend en argument le 1er mot, contenant un 'D', et renvoie le meme mot avec tous les 'D' transformes en 'd' */

remplace_D_par_d([], []).	
remplace_D_par_d(['D' | X], [d | Xd]) :-
	remplace_D_par_d(X, Xd).
remplace_D_par_d([Y | X], [ Y | Xd]) :- 
	(Y \= 'D'),
	remplace_D_par_d(X, Xd).