/* %%%%%% listes.pl %%%%% */

/* OPERATIONS SUR LES LISTES */

/* longueur d'une liste */
longueur([],0).
longueur( [_ | L], N):- longueur(L,N1), (N is N1+1).

/* concatenation de deux listes */
conc([],L,L).
conc( [X | L1], L2, [X | L3]):- conc(L1,L2,L3).

/* appartenance d'un objet a une liste */
membre(X,[X | _]).
membre(X,[_ | Queue]) :- membre(X, Queue).

/* inclusion d'une liste dans une  autre */
sousliste(S,_) :- S = []. 
sousliste(S,L) :- conc(_,L2,L), conc(S,_,L2), S \= [].

%% sousliste(L, Avant, SL, Aprs).

sousliste([A|R], [A|Avant], L0, Apres):-
	sousliste(R,Avant, L0, Apres).

sousliste(L, [], L0, Apres):- 
	conc(L0, Apres, L).


prive(La,S,Lb) :- conc(L1,L2,La), conc(S,L3,L2), conc(L1,L3,Lb).

/* TRANSFORME LA LISTE DES xi EN LA LISTE DES COUPLES (xi/i)*/
liste_numerotee(L,L1):- 
	numero(L,L1,1).


numero([],[],_).
numero([X | L], [X/N| L1],N):-
	N1 is N + 1,
	numero(L,L1,N1).

/* L0 liste normale sousliste d'une liste numerotee avec numero P du 1er terme commun */


sousliste_num(L0,[X/P|L1],P):- 
	enleve_debut([X/P|L1],L0,_).
%	enleve_debut([X/P|L1],L0,_),!.

sousliste_num(L0,[_|L1],P):- 
%	sousliste_num(L0,L1,P),!.
	sousliste_num(L0,L1,P).

/*prive une liste numerotee d'une liste normale */ 
enleve_debut(L,[],L).
enleve_debut([X/_|R0], [X|R1], R2):- enleve_debut(R0,R1,R2), !.

prive_num(L0,L1,L2):- enleve_debut(L0,L1,L2).
prive_num([A|L0],L1,[A|L2]):- prive_num(L0,L1,L2).


/* prive une liste d'un element */

%% enleve(X, L, L1)

enleve(X, [X|L], L).
enleve(X, [A|L], [A|L1]):- 
  enleve(X,L,L1).

/*
   Difference ensembliste 
   
*/

enleve_elements([], L, L).
enleve_elements([A|R], L, L1):-
	(enleve(A,L,L0) -> enleve_elements(R,L0,L1); enleve_elements(R,L,L1)).

    

maprel([], _).

maprel([A|R], REL):- GOAL =.. [REL,A], call(GOAL), maprel(R,REL).

