/* %%%%%% omission_de_terminaison.pl %%%% */

/* TRAITE LES OMISSIONS DE TERMINAISON */


/* cas ou les deux mots sont identiques */
	omission_de_terminaison(T, T, T, T, N, N):- !.

/* cas ou on a une omission de pronom suffixe */

omission_de_terminaison(T1, T2, T1b, T2f, N1, N2):-
	membre('.',T2), /* on a un pronom suffixe dans T2, 
                                          mais non ecrit dans T1 */
	not (membre('.',T1)),!,
	conc(T2a,['.' | X],T2), /* on ne traite que le mot prive
                                                   du pronom suffixe */
	omission_de_terminaison(T1, T2a, T1b, T2b, N1, N2),
      	conc(T2b,['.' | X],T2f). /* on rajoute le pronom suffixe */
	


/*DETECTION DE LA TERMINAISON MANQUANTE */

/* masculin pluriel */

omission_de_terminaison(T1, T2, T2, T2, N1, N2):-
	conc(T1,[w], T2),/* teste si T2 = T1 + w */
	N2 is N1 + 1,!. /*incremente le compteur de differences entre les deux 
                        mots initiaux */

/* masculin duel */

omission_de_terminaison(T1, T2, T2, T2, N1, N2):-
	conc(T1,[y], T2),
	N2 is N1 + 1,!. 

/* feminin pluriel */

omission_de_terminaison(T1, T2, T2, T2, N1, N2):-
	conc(T1,[w,t], T2),
	N2 is N1 + 2,!.

omission_de_terminaison(T1, T2, T2, T2, N1, N2):-
	conc(T1a,[t],T1),
	conc(T1a,[w,t], T2),
	N2 is N1 + 1,!.

/* feminin singulier */

omission_de_terminaison(T1, T2, T2, T2, N1, N2):- 
	conc(T1,[t], T2),
	N2 is N1 + 1,!.

/* feminin duel */

omission_de_terminaison(T1, T2, T2, T2, N1, N2):-
	conc(T1a,[t],T1),
	conc(T1a,[y,t], T2),
	N2 is N1 + 1,!.

omission_de_terminaison(T1, T2, T2, T2, N1, N2):-
	conc(T1,[y,t], T2),
	N2 is N1 + 2,!.
	


