/* %%%%%% transposition_graphique.pl %%%%%%% */

/* SIGNE VERTICAL ETROIT ACCOMPAGNE D'UN OISEAU */
signe_vertical_etroit(X) :- 
liste_des_signes_verticaux_etroits(L),
membre(X,L).


oiseau(X) :- name(X,[ 71| _]).
/* le code du hieroglyphe commence par la lettre 'G', 71 = code ASCII de G */

liste_des_signes_verticaux_etroits(['F25','M4','M5', 'M6', 'M17', 'M22', 'M29', 'M30', 'M40','O30', 'P6', 'P8', 'P11', 'R8', 'R14', 'R16', 'S36', 'S37', 'S38', 'S39', 'S40', 'S41', 'S42', 'S43', 'T3', 'T7A', 'T8', 'T8A', 'T14', 'T15', 'T20', 'T22', 'T23', 'T34', 'T35', 'U23', 'U24', 'U25', 'U26', 'U27', 'U28', 'U29','U32', 'U33', 'U34', 'U36', 'U39', 'V24', 'V25', 'V28', 'V29', 'Y1v', 'Aa20', 'Aa21', 'Aa27', 'Aa28', 'Aa29', 'Aa30', 'Aa32']).

transposition([A,B], [B,A]) :-
	signe_vertical_etroit(A), 
	oiseau(B).

/* il faut alors rectifier [A,B] en [B,A] dans le mot en hieroglyphes*/
 
/* PETIT SIGNE + OISEAU */
petit_signe(X):- 
	liste_des_petits_signes(L),
	membre(X,L).

liste_des_petits_signes(['D1', 'D2', 'D27', 'D27A', 'D54', 'D55', 'F34', 'F52', 'H8', 'K6', 'L6', 'M35', 'M36','M39', 'M41', 'M42', 'N5', 'N8', 'N9', 'N10', 'N14', 'N15', 'N21', 'N23', 'N26', 'N28', 'N29', 'N32', 'N33', 'N34', 'N41', 'O4', 'O5', 'O45', 'O46', 'O47', 'O48', 'O49', 'O50', 'Q3', 'Q4', 'S20', 'S21','T28', 'U3', 'V33', 'V34', 'V35', 'W6','W24', 'X1', 'X2', 'X7', 'Z4', 'Z7', 'Aa1', 'Aa18']).

transposition([A,B], [B,A]) :- 
	petit_signe(A),
	oiseau(B).


/* PETIT SIGNE ENTRE DEUX SIGNES VERTICAUX */

signe_vertical(X) :- 
	liste_des_signes_verticaux(L),
	membre(X,L).

liste_des_signes_verticaux(L) :- 
	liste_des_signes_verticaux_non_etroits(L1), 
	liste_des_signes_verticaux_etroits(L2),
	conc(L1,L2,L).

liste_des_signes_verticaux_non_etroits(['D50', 'D56', 'D58', 'F12', 'F29', 'F31', 'F35', 'F36', 'F45', 'H6', 'H7', 'M13', 'M17', 'M18', 'M22', 'M23', 'M24', 'M32', 'M44', 'O36', 'Q1', 'R11', 'S29']).

transposition([A,B,C], [B,A,C]) :-
	petit_signe(B),
	signe_vertical(A),
	signe_vertical(C).

transposition([A,B,C], [A,C,B]) :-
	petit_signe(B),
	signe_vertical(A),
	signe_vertical(C).
